<?php
namespace topicit\topicit\migrations;

class release_1_0 extends \phpbb\db\migration\migration
{
    public function effectively_installed()
    {
        return($this->config['topicit_version']=='1.0');
    }

    static public function depends_on()
    {
        return array('\phpbb\db\migration\data\v310\alpha2');
    }

    public function update_data()
    {
        return array(
            array('config.add', array('topicit_version', 'alpha0.1')),
            array('config.add', array('topicit_key', '')),
            array('config.add', array('topicit_register_group', '2')),
            array('config.add', array('topicit_auto_approve', '1')),
            array('config.add', array('topicit_deeplinking_enabled', '1')),
            array('config.add', array('topicit_twitter_site', '')),
            array('config.add', array('topicit_sso_enabled', '1')),
            array('config.add', array('topicit_app_banner_enable', '1')),
            array('config.add', array('topicit_directory_enable', '1')),
            array('config.add', array('topicit_add_sig', '1')),
            array('config.add', array('topicit_push_timeout', '5')),
            array('config.add', array('topicit_cron_last_gc', 0)), // last run
            array('config.add', array('topicit_cron_gc', (60 * 60 * 24))), // seconds 
            array('config.add', array('topicit_login' , 1) ),
            array('config.add', array('topicit_login_caption' , '') ),
            array('module.add', array(
                'acp',
                'ACP_CAT_DOT_MODS',
                'PLUG_ACP_TOPICIT_TITLE'
            )),
            array('module.add', array(
                'acp',
                'PLUG_ACP_TOPICIT_TITLE',
                array(
                    'module_basename' => '\topicit\topicit\acp\main_module',
                    'modes'           => array('topicit'),
                ),
            )),
        );
    }

    public function update_schema()
    {
        return array('add_tables' => array(
            $this->table_prefix . 'topicit_users' => array(
                'COLUMNS' => array(
                    'userid'          => array('UINT:10', 0),
                    'userkey'         => array('CHAR:32', NULL, NULL),
                    'token'           => array('CHAR:40', 0),
                    'refresh_token'   => array('CHAR:40', 0),
                    'expires'         => array('UINT:11', 0),
                    'refresh_expires' => array('UINT:11', 0),
                    'sso'             => array('TINT:1', 0),
                ),
                'PRIMARY_KEY' => 'token',
                'KEYS' => array(
                    'userid'            => array('INDEX', 'userid'),
                ),
            )
        ));
    }

    public function revert_schema()
    {
        return array('drop_tables' => array($this->table_prefix . 'topicit_users'));
    }
}
