<?php
/**
* @ignore
*/
namespace topicit\topicit\acp;

error_reporting(0);
if (!defined('IN_PHPBB')) {
	exit;
}
/**
* @package acp
*/
class main_module
{
	public $u_action;
	public $new_config = array();

	function main($id, $mode)
    {
		global $db, $user, $auth, $template, $config, $phpbb_root_path, $phpbb_admin_path, $phpEx;
        
		$action	= request_var('action', '');
		$submit = request_var('submit', '');
		$submit = (!empty($submit)) ? true : false;

		$form_key = 'PLUG_ACP_TOPICIT';
		add_form_key($form_key);
        
		/**
		*	Validation types are:
		*		string, int, bool,
		*		script_path (absolute path in url - beginning with / and no trailing slash),
		*		rpath (relative), rwpath (realtive, writable), path (relative path, but able to escape the root), wpath (writable)
		*/
		switch ($mode) {
			case 'topicit':
                $display_vars = array(
                    'title'	=> 'PLUG_ACP_TOPICIT_SETTINGS',
                    'vars'	=> array(
                        'legend'			          => 'GENERAL_OPTIONS',
                        'topicit_key'		          => array('lang' => 'PLUG_TOPICIT_KEY', 'validate' => 'string','type' => 'text:40:60','explain' => true),
                        'topicit_sso_enabled'	      => array('lang' => 'PLUG_TOPICIT_SSO', 'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
                        'topicit_auto_approve'        => array('lang' => 'PLUG_TOPICIT_AUTO_APPROVE', 'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => false),
                        'topicit_register_group'	  => array('lang' => 'PLUG_TOPICIT_REGISTER_GROUP', 'validate' => 'string',	'type' => 'custom',	'explain' => true,	'method' => 'select_register_group'),
                        'topicit_deeplinking_enabled' => array('lang' => 'PLUG_TOPICIT_ALLOW_DEEPLINKING', 'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
                        'topicit_app_banner_enable'   => array('lang' => 'PLUG_TOPICIT_ALLOW_APP_BANNER', 'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
                        'topicit_add_sig'             => array('lang' => 'PLUG_TOPICIT_ADD_SIG', 'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
                        'topicit_twitter_site'	      => array('lang' => 'PLUG_TOPICIT_TWITTER_SITE', 'validate' => 'string','type' => 'text:40:60','explain' => true),
                        'topicit_login'               => array('lang' => 'PLUG_TOPICIT_LOGIN', 'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
                    )
                );
                break;
		}
		
		if (isset($display_vars['lang'])) {
            $user->add_lang($display_vars['lang']);
		}

		$this->new_config = $config;
		$cfg_array = request_var('config',array('' => ''), true);
		$cfg_array = (!empty($cfg_array)) ? utf8_normalize_nfc(request_var('config', array('' => ''), true)) : $this->new_config;
		$error = array();

		// We validate the complete config if whished
		validate_config_vars($display_vars['vars'], $cfg_array, $error);

		if ($submit && !check_form_key($form_key)) {
            $error[] = $user->lang['FORM_INVALID'];
		}
        
		// Do not write values if there is an error
		if (sizeof($error)) {
            $submit = false;
		}
        
		// We go through the display_vars to make sure no one is trying to set variables he/she is not allowed to...
		foreach ($display_vars['vars'] as $config_name => $null) {
            $this->new_config[$config_name] = $config_value = $cfg_array[$config_name];
            
            if (!isset($cfg_array[$config_name]) || strpos($config_name, 'legend') !== false) {
                continue;
            }
            
            if ($submit) {
                set_config($config_name, $config_value);
            }
		}
		
		if ($submit) {
            add_log('admin', 'LOG_CONFIG_' . strtoupper($mode));
            trigger_error($user->lang['CONFIG_UPDATED'] . adm_back_link($this->u_action));
		}

		$this->tpl_name = 'acp_topicit';
		$this->page_title = $display_vars['title']; 

		$template->assign_vars(array(
            'L_TITLE'			    => $user->lang[$display_vars['title']],
            'L_TITLE_EXPLAIN'	    => $user->lang[$display_vars['title'] . '_EXPLAIN'],
            'L_ACP_TOPICIT_MOD_VER'	=> $user->lang['PLUG_ACP_TOPICIT_MOD_VER'],
            'TOPICIT_MOD_VERSION'	=> $config['topicit_version'],
            'S_ERROR'			    => (sizeof($error)) ? true : false,
            'ERROR_MSG'			    => implode('<br />', $error),
            'U_ACTION'			    => $this->u_action
        ));
        
		// Output relevant page
		foreach($display_vars['vars'] as $config_key => $vars) {
            if (!is_array($vars) && strpos($config_key, 'legend') === false) {
                continue;
            }
            
            if (strpos($config_key, 'legend') !== false) {
                $template->assign_block_vars('options', array(
                    'S_LEGEND'		=> true,
                    'LEGEND'		=> (isset($user->lang[$vars])) ? $user->lang[$vars] : $vars)
                );
                continue;
            }
            
            $type = explode(':', $vars['type']);
            $l_explain = '';
            
            if ($vars['explain'] && isset($vars['lang_explain'])) {
                $l_explain = (isset($user->lang[$vars['lang_explain']])) ? $user->lang[$vars['lang_explain']] : $vars['lang_explain'];
            } elseif ($vars['explain']) {
                $l_explain = (isset($user->lang[$vars['lang'] . '_EXPLAIN'])) ? $user->lang[$vars['lang'] . '_EXPLAIN'] : '';
            }
            
            $content = build_cfg_template($type, $config_key, $this->new_config, $config_key, $vars);
            
            if (empty($content)) {
                continue;
            }
            
            $template->assign_block_vars('options', array(
                'KEY'			=> $config_key,
                'TITLE'			=> (isset($user->lang[$vars['lang']])) ? $user->lang[$vars['lang']] : $vars['lang'],
                'S_EXPLAIN'		=> $vars['explain'],
                'TITLE_EXPLAIN'	=> $l_explain,
                'CONTENT'		=> $content,
            ));
            
            unset($display_vars['vars'][$config_key]);
		}
	}
	
	function select_register_group($value, $key)
    {
		global $db, $user, $config;

		$sql = 'SELECT group_id, group_name, group_type FROM ' . GROUPS_TABLE . " ORDER BY group_type DESC, group_name ASC";
		$result = $db->sql_query($sql);
		
		$s_group_options = '<select id="' . $key . '" name="config[' . $key . ']"  >';
		while ($row = $db->sql_fetchrow($result)) {
			$selected = ($row['group_id'] == $value) ? ' selected="selected"' : '';
			$s_group_options .= '<option' . (($row['group_type'] == GROUP_SPECIAL) ? ' class="sep"' : '') . ' value="' . $row['group_id'] . '"' . $selected . '>' . (($row['group_type'] == GROUP_SPECIAL) ? $user->lang['G_' . $row['group_name']] : $row['group_name']) . '</option>';
		}
		$db->sql_freeresult($result);

		return $s_group_options.'</select>';
	}
}
