<?php
 final class DB { private static $db; private static $debug; private static function connexion() { $app = App::getInstance(); $dbs = $app->config('database'); try { $db = new PDO('mysql:dbname=' . $dbs['master']['database'] . ';host=' . $dbs['master']['hostname'], $dbs['master']['username'], $dbs['master']['password']); } catch (PDOException $e) { error_log('Connexion to master failed: ' . $e->getMessage()); try { $db = new PDO('mysql:dbname=' . $dbs['slave']['database'] . ';host=' . $dbs['slave']['hostname'], $dbs['slave']['username'], $dbs['slave']['password']); } catch (PDOException $e) { Stream::returnAlert('Connexion to slave failed: ' . $e->getMessage()); } } $db->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION); self::$db = $db; } public static function getConnection() { if (self::$db === null) { self::connexion(); } return self::$db; } public static function getDebug() { if (self::$debug === null) { $debug = new stdClass(); $debug->nQuery = 0; self::$debug = $debug; } return self::$debug; } private static function query($statement, $parameters, $fetch, $fetchStyle, $className) { $db = self::getConnection(); try { $pdostatement = $db->prepare($statement); if(!$pdostatement->execute($parameters)) { Stream::returnAlert('Query failed: ' . self::getPDOErrorInfo($pdostatement)); } self::getDebug()->nQuery++; if($fetch) { if($fetch == 'fetch') { $pdostatement->setFetchMode($fetchStyle, $className); return $pdostatement->fetch(); } elseif($fetch == 'fetchAll') { return $pdostatement->fetchAll($fetchStyle, $className); } } return true; } catch (PDOException $e) { Stream::returnAlert('Query failed: ' . $e->getMessage()); } } private static function getPDOErrorInfo($pdo) { $error = $pdo->errorInfo(); return 'SQLSTATE ' . $error[0] . '(' . $error[1] . '): ' . $error[2]; } public static function setLimit($start, $limit) { $return = ''; if (!is_null($limit) && $start >= 0 && $limit >= 0) { $return = ' LIMIT ' . $start . ',' . $limit; } return $return; } public static function getFieldsForQuery($fields) { $filter = (function($value) { if (is_array($value)) { $v = array_values($value); return !empty($v[0]); } else { return !empty($value); } }); $fields = array_filter($fields, $filter); return $fields; } public static function getInsertFields($fields) { $map = (function($field) { return ':' . $field; }); return implode(', ', array_map($map, array_keys($fields))); } public static function getUpdateFields($fields, $except = array()) { $map = (function($field) { return $field . ' = :' . $field; }); foreach ($except as $key) { unset($fields[$key]); } return array_map($map, array_keys($fields)); } public static function select($statement, $parameters = array(), $className = 'stdClass', $fetchStyle = PDO::FETCH_CLASS) { return self::query($statement, $parameters, 'fetchAll', $fetchStyle, $className); } public static function selectObject($statement, $parameters = array(), $className = 'stdClass', $fetchStyle = PDO::FETCH_CLASS) { return self::query($statement, $parameters, 'fetch', $fetchStyle, $className); } public static function insert($statement, $parameters = array(), $className = 'stdClass', $fetchStyle = PDO::FETCH_CLASS) { return self::query($statement, $parameters, false, $fetchStyle, $className); } public static function update($statement, $parameters = array(), $className = 'stdClass', $fetchStyle = PDO::FETCH_CLASS) { return self::query($statement, $parameters, false, $fetchStyle, $className); } public static function delete($statement, $parameters = array(), $className = 'stdClass', $fetchStyle = PDO::FETCH_CLASS) { return self::query($statement, $parameters, false, $fetchStyle, $className); } } 