<?php
 namespace Emojione; class Client implements ClientInterface { public $ascii = false; public $shortcodes = true; public $unicodeAlt = true; public $imageType = 'png'; public $cacheBustParam = '?v=2.2.7'; public $sprites = false; public $imagePathPNG = 'https://cdn.jsdelivr.net/emojione/assets/png/'; public $imagePathSVG = 'https://cdn.jsdelivr.net/emojione/assets/svg/'; public $imagePathSVGSprites = './../../assets/sprites/emojione.sprites.svg'; public $imageTitleTag = true; public $unicode_replaceWith = false; public $ignoredRegexp = '<object[^>]*>.*?<\/object>|<span[^>]*>.*?<\/span>|<(?:object|embed|svg|img|div|span|p|a)[^>]*>'; public $unicodeRegexp = '([*#0-9](?>\\xEF\\xB8\\x8F)?\\xE2\\x83\\xA3|\\xC2[\\xA9\\xAE]|\\xE2..(\\xF0\\x9F\\x8F[\\xBB-\\xBF])?(?>\\xEF\\xB8\\x8F)?|\\xE3(?>\\x80[\\xB0\\xBD]|\\x8A[\\x97\\x99])(?>\\xEF\\xB8\\x8F)?|\\xF0\\x9F(?>[\\x80-\\x86].(?>\\xEF\\xB8\\x8F)?|\\x87.\\xF0\\x9F\\x87.|..((\\xE2\\x80\\x8D\\xF0\\x9F\\x97\\xA8)|(\\xF0\\x9F\\x8F[\\xBB-\\xBF])|(\\xE2\\x80\\x8D\\xF0\\x9F\\x91[\\xA6-\\xA9]){2,3}|(\\xE2\\x80\\x8D\\xE2\\x9D\\xA4\\xEF\\xB8\\x8F\\xE2\\x80\\x8D\\xF0\\x9F..(\\xE2\\x80\\x8D\\xF0\\x9F\\x91[\\xA6-\\xA9])?))?))'; public $shortcodeRegexp = ':([-+\\w]+):'; protected $ruleset = null; public function __construct(RulesetInterface $ruleset = null) { if ( ! is_null($ruleset) ) { $this->ruleset = $ruleset; } } public function toImage($string) { $string = $this->unicodeToImage($string); $string = $this->shortnameToImage($string); return $string; } public function unifyUnicode($string) { $string = $this->toShort($string); $string = $this->shortnameToUnicode($string); return $string; } public function shortnameToUnicode($string) { if ($this->shortcodes) { $string = preg_replace_callback('/'.$this->ignoredRegexp.'|('.$this->shortcodeRegexp.')/Si', array($this, 'shortnameToUnicodeCallback'), $string); } if ($this->ascii) { $ruleset = $this->getRuleset(); $asciiRegexp = $ruleset->getAsciiRegexp(); $string = preg_replace_callback('/'.$this->ignoredRegexp.'|((\\s|^)'.$asciiRegexp.'(?=\\s|$|[!,.?]))/S', array($this, 'asciiToUnicodeCallback'), $string); } return $string; } public function shortnameToAscii($string) { $string = preg_replace_callback('/'.$this->ignoredRegexp.'|('.$this->shortcodeRegexp.')/Si', array($this, 'shortnameToAsciiCallback'), $string); return $string; } public function asciiToShortname($string) { $ruleset = $this->getRuleset(); $asciiRegexp = $ruleset->getAsciiRegexp(); return preg_replace_callback('/'.$this->ignoredRegexp.'|((\\s|^)'.$asciiRegexp.'(?=\\s|$|[!,.?]))/S', array($this, 'asciiToShortnameCallback'), $string); } public function shortnameToImage($string) { if ($this->shortcodes) { $string = preg_replace_callback('/'.$this->ignoredRegexp.'|('.$this->shortcodeRegexp.')/Si', array($this, 'shortnameToImageCallback'), $string); } if ($this->ascii) { $ruleset = $this->getRuleset(); $asciiRegexp = $ruleset->getAsciiRegexp(); $string = preg_replace_callback('/'.$this->ignoredRegexp.'|((\\s|^)'.$asciiRegexp.'(?=\\s|$|[!,.?]))/S', array($this, 'asciiToImageCallback'), $string); } return $string; } public function toShort($string) { return preg_replace_callback('/'.$this->ignoredRegexp.'|'.$this->unicodeRegexp.'/S', array($this, 'toShortCallback'), $string); } public function unicodeToImage($string) { return preg_replace_callback('/'.$this->ignoredRegexp.'|'.$this->unicodeRegexp.'/S', array($this, 'unicodeToImageCallback'), $string); } public function shortnameToAsciiCallback($m) { if ((!is_array($m)) || (!isset($m[1])) || (empty($m[1]))) { return $m[0]; } else { $ruleset = $this->getRuleset(); $shortcode_replace = $ruleset->getShortcodeReplace(); $ascii_replace = $ruleset->getAsciiReplace(); $aflipped = array_flip($ascii_replace); $shortname = $m[0]; if (!isset($shortcode_replace[$shortname])) { return $m[0]; } $unicode = $shortcode_replace[$shortname]; return isset($aflipped[$unicode]) ? $aflipped[$unicode] : $m[0]; } } public function shortnameToUnicodeCallback($m) { if ((!is_array($m)) || (!isset($m[1])) || (empty($m[1]))) { return $m[0]; } else { $ruleset = $this->getRuleset(); $unicode_replace = $ruleset->getUnicodeReplace(); $shortname = $m[1]; if (!array_key_exists($shortname, $unicode_replace)) { return $m[0]; } $unicode = $unicode_replace[$shortname]; return $unicode; } } public function shortnameToImageCallback($m) { if ((!is_array($m)) || (!isset($m[1])) || (empty($m[1]))) { return $m[0]; } else { $ruleset = $this->getRuleset(); $shortcode_replace = $ruleset->getShortcodeReplace(); $shortname = $m[1]; if (!isset($shortcode_replace[$shortname])) { return $m[0]; } $unicode = $shortcode_replace[$shortname]; $filename = $unicode; $titleTag = $this->imageTitleTag ? 'title="'.htmlspecialchars($shortname).'"' : ''; if ($this->unicodeAlt) { $alt = $this->convert($unicode); } else { $alt = $shortname; } if ($this->imageType == 'png') { if ($this->sprites) { return '<span class="emojione emojione-'.$unicode.'" title="'.htmlspecialchars($shortname).'">'.$alt.'</span>'; } else { return '<img class="emojione" alt="'.$alt.'" '.$titleTag.' src="'.$this->imagePathPNG.$filename.'.png'.$this->cacheBustParam.'"/>'; } } if ($this->sprites) { return '<svg class="emojione"><description>'.$alt.'</description><use xlink:href="'.$this->imagePathSVGSprites.'#emoji-'.$unicode.'"></use></svg>'; } else { return '<object class="emojione" data="'.$this->imagePathSVG.$filename.'.svg'.$this->cacheBustParam.'" type="image/svg+xml" standby="'.$alt.'">'.$alt.'</object>'; } } } public function asciiToUnicodeCallback($m) { if ((!is_array($m)) || (!isset($m[3])) || (empty($m[3]))) { return $m[0]; } else { $ruleset = $this->getRuleset(); $ascii_replace = $ruleset->getAsciiReplace(); $shortname = $m[3]; $unicode = $ascii_replace[$shortname]; return $m[2].$this->convert($unicode); } } public function asciiToShortnameCallback($m) { if ((!is_array($m)) || (!isset($m[3])) || (empty($m[3]))) { return $m[0]; } else { $ruleset = $this->getRuleset(); $ascii_replace = $ruleset->getAsciiReplace(); $shortcode_replace = array_flip(array_reverse($ruleset->getShortcodeReplace())); $shortname = $m[3]; $unicode = $ascii_replace[$shortname]; return $m[2].$shortcode_replace[$unicode]; } } public function asciiToImageCallback($m) { if ((!is_array($m)) || (!isset($m[3])) || (empty($m[3]))) { return $m[0]; } else { $ruleset = $this->getRuleset(); $ascii_replace = $ruleset->getAsciiReplace(); $shortname = html_entity_decode($m[3]); $unicode = $ascii_replace[$shortname]; $titleTag = $this->imageTitleTag ? 'title="'.htmlspecialchars($shortname).'"' : ''; if ($this->unicodeAlt) { $alt = $this->convert($unicode); } else { $alt = htmlspecialchars($shortname); } if ($this->imageType == 'png') { if ($this->sprites) { return $m[2].'<span class="emojione emojione-'.$unicode.'" title="'.htmlspecialchars($shortname).'">'.$alt.'</span>'; } else { return $m[2].'<img class="emojione" alt="'.$alt.'" '.$titleTag.' src="'.$this->imagePathPNG.$unicode.'.png'.$this->cacheBustParam.'"/>'; } } if ($this->sprites) { return $m[2].'<svg class="emojione"><description>'.$alt.'</description><use xlink:href="'.$this->imagePathSVGSprites.'#emoji-'.$unicode.'"></use></svg>'; } else { return $m[2].'<object class="emojione" data="'.$this->imagePathSVG.$unicode.'.svg'.$this->cacheBustParam.'" type="image/svg+xml" standby="'.$alt.'">'.$alt.'</object>'; } } } public function toShortCallback($m) { if ((!is_array($m)) || (!isset($m[1])) || (empty($m[1]))) { return $m[0]; } else { $ruleset = $this->getRuleset(); $unicode_replace = $ruleset->getUnicodeReplace(); $unicode = $m[1]; if (!in_array($unicode, $unicode_replace)) { $unicode .= "\xEF\xB8\x8F"; if (!in_array($unicode, $unicode_replace)) { $unicode = substr($m[1], 0, 4); if (!in_array($unicode, $unicode_replace)) { return $m[0]; } } } return array_search($unicode, $unicode_replace); } } public function unicodeToImageCallback($m) { if ((!is_array($m)) || (!isset($m[1])) || (empty($m[1]))) { return $m[0]; } else { $ruleset = $this->getRuleset(); $shortcode_replace = $ruleset->getShortcodeReplace(); $unicode_replace = $ruleset->getUnicodeReplace(); $unicode = $m[1]; if (!in_array($unicode, $unicode_replace)) { $unicode .= "\xEF\xB8\x8F"; if (!in_array($unicode, $unicode_replace)) { $unicode = substr($m[1], 0, 4); if (!in_array($unicode, $unicode_replace)) { if ("\xE2\x83\xA3" === substr($m[1], 1, 3)) { $unicode = substr($m[1], 0, 1) . "\xEF\xB8\x8F\xE2\x83\xA3"; if (!in_array($unicode, $unicode_replace)) { return $m[0]; } } else { return $m[0]; } } } } $shortname = array_search($unicode, $unicode_replace); $filename = $shortcode_replace[$shortname]; $titleTag = $this->imageTitleTag ? 'title="'.htmlspecialchars($shortname).'"' : ''; if ($this->unicodeAlt) { $alt = $unicode; } else { $alt = $shortname; } if ($this->imageType == 'png') { if ($this->sprites) { return '<span class="emojione emojione-'.$filename.'" title="'.htmlspecialchars($shortname).'">'.$alt.'</span>'; } else { return '<img class="emojione" alt="'.$alt.'" '.$titleTag.' title="'.htmlspecialchars($shortname).'" src="'.$this->imagePathPNG.$filename.'.png'.$this->cacheBustParam.'"/>'; } } if ($this->sprites) { return '<svg class="emojione"><description>'.$alt.'</description><use xlink:href="'.$this->imagePathSVGSprites.'#emoji-'.$filename.'"></use></svg>'; } else { return '<object class="emojione" data="'.$this->imagePathSVG.$filename.'.svg'.$this->cacheBustParam.'" type="image/svg+xml" standby="'.$alt.'">'.$alt.'</object>'; } } } public function convert($unicode) { if (stristr($unicode,'-')) { $pairs = explode('-',$unicode); return '&#x'.implode(';&#x',$pairs).';'; } else { return '&#x'.$unicode.';'; } } public function getRuleset() { if ( $this->ruleset === null ) { $this->ruleset = new Ruleset; } return $this->ruleset; } } 