<?php
 interface MessageInterface { public static function newMessage($in); public static function getMessageQuotat(); public static function getBoxInfo($boxId); public static function getMessageList($boxId, $start, $limit); public static function getMessage($boxId, $msgId, $html); public static function quoteMessage($msgId); public static function deleteMessage($boxId, $msgId); public static function markRead($msgIds); public static function markUnread($msgId); public static function report($msgId, $reason); public static function getAllMessagesList($start, $limit); public static function getConversation($id, $review, $html); } final class TIMessageController extends Controller { public function newMessage() { $app = App::getInstance(); $in = array( 'usernames' => $app->request->post('usernames'), 'subject' => $app->request->post('subject'), 'body' => $app->request->post('body'), 'action' => $app->request->post('action'), 'msgId' => $app->request->post('msgId'), ); TIValidator::is_valid($in, array( 'usernames' => 'required|valid_json_string', 'subject' => 'required', 'body' => 'required', )); $in['usernames'] = json_decode($in['usernames'], true); $in['usernames'] = $in['usernames']['usernames']; $msgId = MessageController::newMessage($in); $return = new stdClass(); $return->datas = array( 'result' => true, 'msg_id' => $msgId ); return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } public function getBoxInfo() { $msgCount = MessageController::getMessageQuotat(); $boxs = TIFunctions::getOutput(MessageController::getBoxInfo()); $return = new stdClass(); $return->datas = array( 'result' => true, 'message_room_count' => $msgCount, 'list' => $boxs ); return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } public function getMessageList($boxId) { $start = TIFunctions::getDefaultVal(App::getInstance()->request->get('start')); $limit = TIFunctions::getDefaultVal(App::getInstance()->request->get('limit'), 20); $box = MessageController::getBoxInfo($boxId)->output(); $pms = TIFunctions::getOutput(MessageController::getMessageList($boxId, $start, $limit)); $return = new stdClass(); $return->datas = array_merge(array( 'result' => true, 'list' => $pms ), $box); return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } public function getMessage($boxId , $msgId) { $html = App::getInstance()->request->get('return_html'); $review = []; if (App::getInstance()->request->get('review', false)) { $start = TIFunctions::getDefaultVal((int)App::getInstance()->request->get('review_start_num'), 0); $limit = TIFunctions::getDefaultVal((int)App::getInstance()->request->get('review_last_num'), 10); $review = [ 'start_num' => $start, 'last_num' => $limit - $start + 1, ]; } if (!$message = MessageController::getMessage($boxId, (int)$msgId, $review, $html)) { TIFunctions::generateError('MESSAGE_DENIED'); } $return = new stdClass(); $return->datas['result'] = true; $return->datas = $message->output(); return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } public function quoteMessage($msgId) { $quotePm = MessageController::quoteMessage((int)$msgId)->output(); $return = new stdClass(); $return->datas = array_merge(array( 'result' => true, ), $quotePm); return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } public function deleteMessage($boxId, $msgId) { $return = new stdClass(); $return->datas = array( 'result' => MessageController::deleteMessage($boxId ,(int)$msgId) ); return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } public function markRead($msgIds = null) { $return = new stdClass(); $return->datas = array( 'result' => MessageController::markRead($msgIds) ); return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } public function markUnread($msgId) { $return = new stdClass(); $return->datas = array( 'result' => MessageController::markUnread((int)$msgId) ); return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } public function report($msgId) { TIFunctions::checkSupport('reportPm'); $reason = App::getInstance()->request->post('reason'); $result = MessageController::report((int)$msgId, $reason); if ($result === true) { $return = new stdClass(); $return->datas['result'] = true; $return->datas['result_text'] = 'Private message reported'; } else { $return = new stdClass(); $return->datas['result'] = false; $return->datas['result_text'] = $result; } return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } public function getAllMessagesList() { $start = TIFunctions::getDefaultVal(App::getInstance()->request->get('start')); $limit = TIFunctions::getDefaultVal(App::getInstance()->request->get('limit'), 40); $pms = TIFunctions::getOutput(MessageController::getAllMessagesList($start, $limit)); $return = new stdClass(); $return->datas = array( 'result' => true, 'list' => $pms ); return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } public function getConversation($id) { $html = App::getInstance()->request->get('return_html'); $review = []; if (App::getInstance()->request->get('review', true)) { $start = TIFunctions::getDefaultVal((int)App::getInstance()->request->get('review_start_num'), 0); $limit = TIFunctions::getDefaultVal((int)App::getInstance()->request->get('review_last_num'), 10); $review = [ 'start_num' => $start, 'last_num' => $limit - $start + 1, ]; } if (!$message = MessageController::getConversation((int)$id, $review, $html)) { TIFunctions::generateError('MESSAGE_DENIED'); } $return = new stdClass(); $return->datas['result'] = true; $return->datas = $message->output(); return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } } 