<?php
 interface ModerationInterface { public static function stickTopic($topicId, $in); public static function closeTopic($topicId, $in); public static function deleteTopic($topicId, $in); public static function undeleteTopic($topicId, $in); public static function moveTopic($topicId, $in); public static function renameTopic($topicId, $in); public static function mergeTopic($in); public static function approveTopic($topicId, $in); public static function editPost($postId, $in); public static function deletePost($postId, $in); public static function undeletePost($postId, $in); public static function movePost($in); public static function mergePost($in); public static function approvePost($postId, $in); public static function modSearch($mode, $start, $limit); public static function banUser($userId, $in); public static function spamUser($userId); public static function unbanUser($userId); public static function closeReport($reportId); } final class TIModerationController extends Controller { public function __construct() { $this->app = App::getInstance(); } public function stickTopic($topicId) { $in = array( 'mode' => $this->app->request->post('mode') ); TIValidator::is_valid($in, array( 'mode' => 'required', )); ModerationController::stickTopic((int)$topicId, $in); return Stream::returnSuccess(); } public function closeTopic($topicId) { $in = array( 'mode' => $this->app->request->post('mode') ); TIValidator::is_valid($in, array( 'mode' => 'required', )); ModerationController::closeTopic((int)$topicId, $in); return Stream::returnSuccess(); } public function deleteTopic($topicId) { $in = array( 'mode' => $this->app->request->post('mode'), 'reason_text' => $this->app->request->post('reason_text') ); TIValidator::is_valid($in, array( 'mode' => 'required|min_numeric,1|max_numeric,2', )); ModerationController::deleteTopic((int)$topicId, $in); return Stream::returnSuccess(); } public function undeleteTopic($topicId) { $in = array( 'reason_text' => $this->app->request->post('reason_text') ); ModerationController::undeleteTopic((int)$topicId, $in); return Stream::returnSuccess(); } public function moveTopic($topicId) { $in = array( 'forum_id' => $this->app->request->post('forum_id') ); TIValidator::is_valid($in, array( 'forum_id' => 'required|integer', )); ModerationController::moveTopic((int)$topicId, $in); return Stream::returnSuccess(); } public function renameTopic($topicId) { $in = array( 'title' => $this->app->request->post('title'), 'prefix_id' => $this->app->request->post('prefix_id') ); ModerationController::renameTopic((int)$topicId, $in); return Stream::returnSuccess(); } public function mergeTopic() { $in = array( 'topic_id_from' => $this->app->request->post('topic_id_from'), 'topic_id_to' => $this->app->request->post('topic_id_to'), 'redirect' => $this->app->request->post('redirect') ); TIValidator::is_valid($in, array( 'topic_id_from' => 'required|integer', 'topic_id_to' => 'required|integer', )); ModerationController::mergeTopic($in); return Stream::returnSuccess(); } public function approveTopic($topicId) { $in = array( 'mode' => $this->app->request->post('mode') ); TIValidator::is_valid($in, array( 'mode' => 'required', )); ModerationController::approveTopic((int)$topicId, $in); return Stream::returnSuccess(); } public function moderateTopicList() { $start = TIFunctions::getDefaultVal($this->app->request->get('start_num')); $limit = TIFunctions::getDefaultVal($this->app->request->get('last_num'), 20) - $start + 1; $result = ModerationController::modSearch('topicAwaitingModeration', $start, $limit); $return = new stdClass(); $return->datas = array( 'total_topic_num' => (int)$result['total'], 'topics' => TIFunctions::getOutput($result['topics']), ); return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } public function deletedTopicList() { $start = TIFunctions::getDefaultVal($this->app->request->get('start_num')); $limit = TIFunctions::getDefaultVal($this->app->request->get('last_num'), 20) - $start + 1; $result = ModerationController::modSearch('topicDeleted', $start, $limit); $return = new stdClass(); $return->datas = array( 'total_topic_num' => (int)$result['total'], 'topics' => TIFunctions::getOutput($result['topics']), ); return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } public function editPost($postId) { $in = array( 'title' => $this->app->request->post('post_title'), 'content' => $this->app->request->post('post_content'), 'reason' => $this->app->request->post('reason') ); TIValidator::is_valid($in, array( 'content' => 'required' )); ModerationController::editPost($postId, $in); Stream::returnSuccess(); } public function deletePost($postId) { $in = array( 'mode' => $this->app->request->post('mode'), 'reason_text' => $this->app->request->post('reason_text'), ); TIValidator::is_valid($in, array( 'mode' => 'required|min_numeric,1|max_numeric,2', )); ModerationController::deletePost((int)$postId, $in); return Stream::returnSuccess(); } public function undeletePost($postId) { $in = array( 'reason_text' => $this->app->request->port('reason_text') ); ModerationController::undeletePost((int)$postId, $in); return Stream::returnSuccess(); } public function movePost() { $in = array( 'post_ids' => $this->app->request->post('post_ids'), 'topic_id' => $this->app->request->post('topic_id'), 'topic_title' => $this->app->request->post('topic_title'), 'forum_id' => $this->app->request->post('forum_id') ); TIValidator::is_valid($in, array( 'post_ids' => 'required|integer', 'topic_id' => 'integer', 'topic_title' => 'integer', 'forum_id' => 'integer', )); ModerationController::movePost($in); return Stream::returnSuccess(); } public function mergePost() { $in = array( 'post_ids' => $this->app->request->post('post_ids'), 'post_id' => $this->app->request->post('post_id') ); TIValidator::is_valid($in, array( 'post_ids' => 'required|integer', 'post_id' => 'required|integer', )); ModerationController::mergePost($in); return Stream::returnSuccess(); } public function approvePost($postId) { $in = array( 'mode' => $this->app->request->post('mode') ); TIValidator::is_valid($in, array( 'mode' => 'required', )); ModerationController::approvePost((int)$postId, $in); return Stream::returnSuccess(); } public function moderatePostList() { $start = TIFunctions::getDefaultVal($this->app->request->get('start_num')); $limit = TIFunctions::getDefaultVal($this->app->request->get('last_num'), 20) - $start + 1; $result = ModerationController::modSearch('postAwaitingModeration', $start, $limit); $return = new stdClass(); $return->datas = array( 'total_post_num' => (int)$result['total'], 'posts' => TIFunctions::getOutput($result['posts']), ); return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } public function deletedPostList() { $start = TIFunctions::getDefaultVal($this->app->request->get('start_num')); $limit = TIFunctions::getDefaultVal($this->app->request->get('last_num'), 20) - $start + 1; $result = ModerationController::modSearch('postDeleted', $start, $limit); $return = new stdClass(); $return->datas = array( 'total_post_num' => (int)$result['total'], 'posts' => TIFunctions::getOutput($result['posts']), ); return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } public function banUser($userId) { $in = array( 'mode' => $this->app->request->post('mode'), 'reason_text' => $this->app->request->post('reason_text'), 'expires' => $this->app->request->post('expires', 0), ); TIValidator::is_valid($in, array( 'mode' => 'required', )); ModerationController::banUser((int)$userId, $in); return Stream::returnSuccess(); } public function spamUser($userId) { ModerationController::spamUser((int)$userId); return Stream::returnSuccess(); } public function unbanUser($userId) { ModerationController::unbanUser((int)$userId); return Stream::returnSuccess(); } public function reportList() { $start = TIFunctions::getDefaultVal($this->app->request->get('start_num')); $limit = TIFunctions::getDefaultVal($this->app->request->get('last_num'), 20) - $start + 1; $result = ModerationController::modSearch('postReported', $start, $limit); $return = new stdClass(); $return->datas = array( 'total_post_num' => (int)$result['total'], 'reports' => TIFunctions::getOutput($result['posts']), ); return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } public function closeReport($reportId) { ModerationController::closeReport((int)$reportId); return Stream::returnSuccess(); } } 