<?php
 interface SubscriptionInterface { public static function get($type, $start, $limit); } final class TISubscriptionController extends Controller { public function get($type) { $app = App::getInstance(); $output = array(); switch($type) { case 'topic': $start = TIFunctions::getDefaultVal($app->request->get('start_num')); $limit = TIFunctions::getDefaultVal($app->request->get('last_num'), 20) - $start + 1; $tids = array_map(function($s){ return $s->key; }, SubscriptionController::get($type, $start, $limit)); $topics = TopicModel::getTopicsByIds($tids); foreach($topics as $topic) { $output[] = array( 'forum_id' => $topic->forumId, 'forum_name' => $topic->getForum()->forumName, 'topic_id' => $topic->topicId, 'topic_title' => $topic->topicTitle, 'post_author_name' => $topic->getAuthorName(), 'is_closed' => $topic->isClosed, 'icon_url' => null, 'post_time' => $topic->postTime, 'reply_number' => $topic->replyNumber, 'new_post' => $topic->newPost, 'view_number' => $topic->viewNumber, 'short_content' => $topic->shortContent ); } $return = new stdClass(); $return->datas = array( 'total_topic_num' => count($output), 'topics' => $output ); break; case 'forum': $tids = array_map(function($s){ return $s->key; }, SubscriptionController::get($type)); $forums = ForumModel::getForumsByIds($tids); foreach($forums as $forum) { $output[] = array( 'forum_id' => $forum->forumId, 'forum_name' => $forum->forumName, 'icon_url' => null, 'is_protected' => $forum->isProtected, 'new_post' => $forum->newPost, ); } $return = new stdClass(); $return->datas = array( 'total_forums_num' => count($output), 'forums' => $output ); break; } return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } public function post($type, $id) { TIValidator::is_valid(array('id' => $id), array( 'id' => 'integer' )); if (SubscribeModel::getSubById($type, $id)) { TIFunctions::generateError('SUBSCRIBE_ALREADY_SUBSCRIBED'); } $subscription = new SubscribeModel($type, 0, array($type . "_id" => $id)); if (!$subscription->save()) { TIFunctions::generateError('SUBSCRIBE_INSERT_ERROR'); } $return = new stdClass(); $return->datas = array( 'result_text' => 'INSERT_OK', 'result' => true ); return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } public function delete($type, $id) { TIValidator::is_valid(array('id' => $id), array( 'id' => 'integer' )); if (!$subscription = SubscribeModel::getSubById($type , $id)) { TIFunctions::generateError('SUBSCRIBE_NOT_EXISTS'); } if (!$subscription->delete()) { TIFunctions::generateError('SUBSCRIBE_DELETE_ERROR'); } $return = new stdClass(); $return->datas = array( 'result_text' => 'DELETE_OK', 'result' => true ); return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } } 