<?php
 interface TopicInterface { public static function getTopics($forumId, $start, $limit, $mode); public static function newTopic($in); public static function markRead($topicIds); public static function getTopicsByIdList($idList); public static function getFollowed($start, $limit); } final class TITopicController extends Controller { public function __construct() { $this->app = App::getInstance(); } public function getTopics($forumId) { $start = TIFunctions::getDefaultVal($this->app->request->get('start_num')); $limit = TIFunctions::getDefaultVal($this->app->request->get('last_num'), 20) - $start + 1; $mode = $this->app->request->get('mode'); $forum = array(); $topics = TopicController::getTopics($forumId, $start, $limit, $mode); $return = new stdClass(); $return->datas = array_merge($forum, array( 'topics' => TIFunctions::getOutput($topics) )); return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } public function newTopic() { $in = array( 'forumId' => $this->app->request->post('forum_id'), 'subject' => $this->app->request->post('subject'), 'body' => $this->app->request->post('text_body'), 'prefix' => $this->app->request->post('prefix_id'), 'attachmentIds' => (array)$this->app->request->post('attachment_id_array'), 'groupId' => $this->app->request->post('group_id') ); $in['subject'] = preg_replace(\Emojione\Emojione::getClient()->unicodeRegexp, '', $in['subject']); TIValidator::is_valid($in, array( 'forumId' => 'required|integer', 'subject' => 'required', 'body' => 'required', )); $data = TopicController::newTopic($in); $return = new stdClass(); $return->datas = TIFunctions::filterNullValues(array( 'result' => true, 'topic_id' => $data['topic_id'], 'state' => !$data['topic_approved'] ? 1 : null, )); return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } public function markRead($topicIds) { $topicIds = explode(',', $topicIds); $return = new stdClass(); $return->datas['result'] = TopicController::markRead($topicIds); return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } public function getLatest() { define('IN_TOPICIT_FEED', true); $start = TIFunctions::getDefaultVal($this->app->request->get('start_num')); $limit = TIFunctions::getDefaultVal($this->app->request->get('last_num'), 20) - $start + 1; $result = SearchController::search('getLatest', $start, $limit); $return = new stdClass(); $return->datas = TIFunctions::filterNullValues(array( 'result' => true, 'total_topic_num' => (int)$result['total'], 'topics' => TIFunctions::getOutput($result['topics']), )); return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } public function getFollowed() { if (! method_exists(TopicController::class, 'getFollowed')) { Stream::returnError('GENERAL_MOD_DISABLED'); exit(); } $start = TIFunctions::getDefaultVal($this->app->request->get('start_num')); $limit = TIFunctions::getDefaultVal($this->app->request->get('last_num'), 18) - $start + 1; try { $followedTopics = TopicController::getFollowed($start, $limit); } catch(\PluginFa\Exceptions\GeneralModDisabled $e) { Log::info('GENERAL_NOT_CONNECTED : ' . $e->getMessage() . ' [' . $e->getFile() . '] [LINE : ' . $e->getLine() . ']'); Stream::returnError("GENERAL_NOT_CONNECTED"); exit(); } catch (Exception $e) { Log::error('GENERAL_ERROR : ' . $e->getMessage() . ' [' . $e->getFile() . '] [LINE : ' . $e->getLine() . ']'); Stream::returnError("GENERAL_ERROR"); exit(); } $return = new stdClass(); $return->datas = TIFunctions::filterNullValues([ 'result' => true, 'topics' => empty($followedTopics) ? [] : TIFunctions::getOutput($followedTopics), ]); Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } public function getUnread() { $start = TIFunctions::getDefaultVal($this->app->request->get('start_num')); $limit = TIFunctions::getDefaultVal($this->app->request->get('last_num'), 20) - $start + 1; $result = SearchController::search('getUnread', $start, $limit); $return = new stdClass(); $return->datas = TIFunctions::filterNullValues(array( 'result' => true, 'total_topic_num' => (int)$result['total'], 'topics' => TIFunctions::getOutput($result['topics']), )); return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } public function getParticipated($id) { $start = TIFunctions::getDefaultVal($this->app->request->get('start_num')); $limit = TIFunctions::getDefaultVal($this->app->request->get('last_num'), 20) - $start + 1; $filter = array( 'id' => $id, 'by' => $this->app->request->get('by', 'id') ); if ($filter['by'] == 'id') { TIValidator::is_valid($filter, array( 'id' => 'integer' )); } $result = SearchController::search('getParticipated', $start, $limit, $filter); $return = new stdClass(); $return->datas = TIFunctions::filterNullValues(array( 'result' => true, 'total_topic_num' => (int)$result['total'], 'total_unread_num' => $result['unread'], 'topics' => TIFunctions::getOutput($result['topics']), )); return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } public function getPopular() { $start = TIFunctions::getDefaultVal($this->app->request->get('start_num')); $limit = TIFunctions::getDefaultVal($this->app->request->get('last_num'), 20) - $start + 1; $result = SearchController::search('popular', $start, $limit); $return = new stdClass(); $return->datas = TIFunctions::filterNullValues(array( 'result' => true, 'total_topic_num' => count($result), 'topics' => TIFunctions::getOutput($result), )); return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } public function getActive() { $start = TIFunctions::getDefaultVal($this->app->request->get('start_num')); $limit = TIFunctions::getDefaultVal($this->app->request->get('last_num'), 20) - $start + 1; $result = SearchController::search('active', $start, $limit); $return = new stdClass(); $return->datas = TIFunctions::filterNullValues(array( 'result' => true, 'total_topic_num' => count($result), 'topics' => TIFunctions::getOutput($result), )); return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } public function getTopicsByIdList() { $idList = TIFunctions::getDefaultVal($this->app->request->get('topic_list')); $idList = array_unique(explode(',', $idList), SORT_NUMERIC); $topics = TopicController::getTopicsByIdList($idList); $return = new stdClass(); $return->datas = TIFunctions::filterNullValues(array( 'result' => true, 'total_topic_num' => count($topics), 'topics' => TIFunctions::getOutput($topics), )); return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } public function getUserTopics($id) { define('IN_TOPICIT_FEED', true); $filter = array( 'id' => $id, 'by' => $this->app->request->get('by', 'id') ); if ($filter['by'] == 'id') { TIValidator::is_valid($filter, array( 'id' => 'integer' )); } $result = SearchController::search('getUserTopics', 0, 50, $filter); $return = new stdClass(); $return->datas = TIFunctions::getNodeOutput($result['topics']); return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } public function getUserReplies($id) { define('IN_TOPICIT_FEED', true); $filter = array( 'id' => $id, 'by' => $this->app->request->get('by', 'id') ); if ($filter['by'] == 'id') { TIValidator::is_valid($filter, array( 'id' => 'integer' )); } $result = SearchController::search('getUserReplies', 0, 50, $filter); $output = array(); foreach ($result['posts'] as $post) { $output[] = TIFunctions::filterNullValues(array_merge($post->getTopic()->nodeOutput(), array( 'post_id' => $post->postId, 'post_time' => $post->postTime, 'short_content' => $post->shortContent ))); } $return = new stdClass(); $return->datas = $output; return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } } 