<?php
 interface UserInterface { public static function getAvatar($id, $by); public static function getUserInfo($id, $by); public static function logIn($username, $password, $anonymous, $userkey); public static function logOut(); public static function retrievePassword($id, $by); public static function getOnlineUsers($in); public static function getUsers($by, $in); public static function addFriend($id); public static function removeFriend($id); public static function getFriends($id); public static function updatePassword($in); public static function updateEmail($in); } final class TIUserController extends Controller { public function getAvatar($id) { TIFunctions::checkSupport('avatar'); $by = App::getInstance()->request->get('by', 'id'); if ($by == 'id') { TIValidator::is_valid(array('id' => $id), array( 'id' => 'integer' ) ); } $return = new stdClass(); $return->datas = UserController::getAvatar($id, $by); return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } public function getUserInfo($id) { $by = App::getInstance()->request->get('by', 'id'); if ($by == 'id') { TIValidator::is_valid(array('id' => $id), array( 'id' => 'integer' ) ); } if (!$user = UserController::getUserInfo($id, $by)) { Stream::returnError('USER_NOT_EXISTS'); } $return = new stdClass(); $return->data = $user->output(); return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } public function logIn() { $in = array( 'username' => App::getInstance()->request->post('username'), 'password' => App::getInstance()->request->post('password'), 'anonymous' => TIFunctions::checkSupport('anonymousLogin', false) ? App::getInstance()->request->post('anonymous') : false, 'userkey' => App::getInstance()->request->post('userkey'), ); TIValidator::is_valid($in, array( 'username' => 'required', 'password' => 'required', 'userkey' => 'exact_len,32', )); $return = TIAccountController::getLoginOutput(UserController::logIn($in['username'], $in['password'], $in['anonymous'], $in['userkey'])); return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } public function logOut() { $return = new stdClass(); $return->datas = UserController::logOut(); return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } public function retrievePassword($id) { $by = App::getInstance()->request->post('by', 'email'); if ($by == 'id') { TIValidator::is_valid(array('id' => $id), array( 'id' => 'integer' ) ); } $return = new stdClass(); $return->datas = UserController::retrievePassword($id, $by); return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } public function getInboxStats() { $return = new stdClass(); $inbox = MessageController::getBoxInfo('INBOX'); $return->datas = array( 'inbox_unread_count' => $inbox->unreadCount, 'subscribed_topic_unread_count' => null ); return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } public function getOnlineUsers() { $return = new stdClass(); $in = array( 'page' => TIFunctions::getDefaultVal(App::getInstance()->request->get('page'), 1), 'perpage' => TIFunctions::getDefaultVal(App::getInstance()->request->get('perpage'), 20), 'id' => App::getInstance()->request->get('id'), ); TIValidator::is_valid($in, array( 'id' => 'integer', )); $online = UserController::getOnlineUsers($in); $return->datas = array( 'member_count' => $online['registered'], 'guest_count' => $online['guest'], 'hidden_count' => $online['hidden'], 'list' => $online['list'] ); return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } public function getRecommandedUsers() { TIFunctions::checkSupport('userRecommended'); $return = new stdClass(); $in = array( 'page' => TIFunctions::getDefaultVal(App::getInstance()->request->get('page')), 'perpage' => TIFunctions::getDefaultVal(App::getInstance()->request->get('perpage'), 20), ); $return->datas = UserController::getUsers('recommanded', $in); return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } public function searchUser($keyword) { TIFunctions::checkSupport('searchUser'); $return = new stdClass(); $in = array( 'page' => TIFunctions::getDefaultVal(App::getInstance()->request->get('page')), 'perpage' => TIFunctions::getDefaultVal(App::getInstance()->request->get('perpage'), 20), 'keywords' => $keyword, ); TIValidator::is_valid($in, array( 'keywords' => 'required', )); $return->datas = UserController::getUsers('byUsername', $in); return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } public function addFriend() { TIFunctions::checkSupport('addFriend'); $return = new stdClass(); $in = array( 'userId' => TIFunctions::getDefaultVal(App::getInstance()->request->post('user_id')), ); TIValidator::is_valid($in, array( 'userId' => 'required|integer', )); $return->datas = UserController::addFriend($in['userId']); return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } public function removeFriend($id) { TIFunctions::checkSupport('addFriend'); $return = new stdClass(); $return->datas = UserController::removeFriend($id); return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } public function getFriends($id = null) { TIFunctions::checkSupport('addFriend'); $return = new stdClass(); $return->datas = UserController::getFriends($id); return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } public function updatePassword() { $in = array( 'old_password' => App::getInstance()->request->put('old_password'), 'new_password' => App::getInstance()->request->put('new_password'), ); TIValidator::is_valid($in, array( 'old_password' => 'required', 'new_password' => 'required', )); $return = new stdClass(); $return->datas = UserController::updatePassword($in); return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } public function updateEmail() { $in = array( 'email' => App::getInstance()->request->put('email'), 'password' => App::getInstance()->request->put('password'), ); TIValidator::is_valid($in, array( 'email' => 'required', )); $return = new stdClass(); $return->datas = UserController::updateEmail($in); return Stream::getInstance()->setDefaultHeaderCache()->makeResponse($return); } } 