<?php
 abstract class TIFunctions { public static function filterNullValues($array) { $filter = (function($value) { return !is_null($value); }); return array_filter($array, $filter); } public static function clean($str) { $str = preg_replace('/<br\s*\/?>/si', "\n", $str); $str = strip_tags($str); $str = trim($str); return html_entity_decode($str, ENT_QUOTES, 'UTF-8'); } public static function checkSupport($method, $exit = true) { if (!TIBoardController::getBoardConfig()->$method) { if ($exit) { Stream::returnError('GENERAL_MOD_DISABLED'); } return false; } return true; } public static function getDefaultVal($val, $default = null) { if (empty($val)) { $val = is_null($default) ? 0 : $default; } return $val; } public static function getOutput($objects) { if (!is_array($objects)) $objects = array($objects); return !empty($objects) ? array_map(function($pm) { return $pm->output(); }, $objects) : array(); } public static function getNodeOutput($objects) { if (!is_array($objects)) $objects = array($objects); return !empty($objects) ? array_map(function($pm) { return $pm->nodeOutput(); }, $objects) : array(); } public static function parseHeaders($headers) { $head = array(); if (is_array($headers)) { foreach ($headers as $k => $v) { $t = explode(':', $v, 2); if (isset($t[1])) { $head[ trim($t[0]) ] = trim($t[1]); } else { $head[] = $v; if (preg_match("#HTTP/[0-9\.]+\s+([0-9]+)#",$v, $out)) { $head['response_code'] = intval($out[1]); } } } } return $head; } public static function generateError($key , $args = null, $field = null, $return = true) { $error = array( 'field' => $field, 'key' => $key, 'args' => $args, ); if ($return) { Stream::returnError(self::filterNullValues($error)); } else { return self::filterNullValues($error); } } public static function cast($value, $type = 'string', $forced = false) { if (!is_null($value) || $forced) { switch ($type) { case 'bool': return (boolean)$value; break; case 'int': return (int)$value; break; case 'array': return (array)$value; break; case 'string': default: return (string)$value; break; } } return $value; } } 