<?php
 final class PostController implements PostInterface { public static function reportPost($in) { global $user,$phpbb_root_path, $phpEx, $template, $request; if (!$post = PostController::getPost($in['postId'])) { TIFunctions::generateError('POST_NOT_EXISTS'); } if (!$post->canReport) { TIFunctions::generateError('GENERAL_DENIED'); } require __DIR__ . '/../clones/template.php'; $template = new Template(); $request->overwrite('f', $post->forumId); $request->overwrite('p', $post->postId); $request->overwrite('reason_id', 4); $request->overwrite('report_text', $in['reason']); $request->overwrite('submit', true, \phpbb\request\request_interface::POST); include_once __DIR__ . '/../clones/report.php'; $result = ''; $error = $template->getTemplateVar('ERROR'); if (isset($error) && !empty($error)) { $errors = explode('<br />', $error); if (is_array($errors)) { $result = $errors[0]; } else { $result = $error; } } return array( 'result' => true, 'result_text' => $result ); } public static function newReply($in) { if (!$forum = ForumModel::getForumById($in['forumId'])) { TIFunctions::generateError('FORUM_NOT_EXISTS'); } if (!$topic = TopicModel::getTopicById($in['topicId'])) { TIFunctions::generateError('TOPIC_NOT_EXISTS'); } self::checkAclReplyPost($forum, $topic); $post = PostController::post($in, $topic, $forum); return $post; } public static function getPosts($topicId, $start, $limit, $html) { global $request, $template, $user, $auth, $phpbb_home, $config, $attachment_by_id, $forum_id, $topic_id, $support_post_thanks, $topic_data, $total_posts, $can_subscribe, $post_data; $post_data = null; $request->overwrite('st', 0); $request->overwrite('sk', 't'); $request->overwrite('sd', 'a'); $request->overwrite('t', $topicId); $request->overwrite('start', $start); $request->overwrite('limit', $limit); require __DIR__ . '/../clones/viewtopic.php'; $posts = array(); foreach ($post_data as $post) { $posts[] = new PostModel($post['bind']); } return $posts; } public static function getPost($postId) { global $request, $template, $user, $auth, $phpbb_home, $config, $attachment_by_id, $forum_id, $topic_id, $support_post_thanks, $topic_data, $post_data, $total_posts, $can_subscribe, $last_error; $topic_data = null; $post_data = null; $request->overwrite('st', 0); $request->overwrite('sk', 't'); $request->overwrite('sd', 'a'); $request->overwrite('p', $postId); $request->overwrite('limit', 1); require __DIR__ . '/../clones/viewtopic.php'; $post = new PostModel(array_merge($post_data[0]['bind'], $topic_data)); self::checkAclGetPost($post); return !empty($post) ? $post : false; } public static function getQuotePost($postIds) { global $user; $postTitle = ''; $postContent = ''; foreach ($postIds as $postId) { if ($post = self::getPost($postId)) { self::checkAclGetQuotePost($post); if (empty($postTitle)) { $postTitle = $user->lang['Re'] . ': ' . $post->postTitle; } $postContent .= $post->getQuote(); } } return array( 'ids' => implode('-', $postIds), 'title' => $postTitle, 'content' => $postContent ); } public static function editPost($in) { global $db, $auth, $user, $config, $phpbb_root_path, $phpEx, $mobiquo_config, $phpbb_home, $template; if (!$post = PostController::getPost($in['postId'])) { TIFunctions::generateError('POST_NOT_EXISTS'); } self::checkAclGetPost($post, true); include $phpbb_root_path . 'includes/message_parser.' . $phpEx; $user->setup('posting'); $submit = true; $preview = false; $refresh = false; $mode = 'edit'; $postId = $in['postId']; $postTitle = $in['title']; $postContent = $in['content']; $attachList = $in['attachmentIds']; $attachmentData = $in['groupId']; $reason = $in['reason']; $sql = 'SELECT p.*, t.*, f.*, u.username
                FROM ' . POSTS_TABLE . ' p
                LEFT JOIN ' . TOPICS_TABLE . ' t ON (p.topic_id = t.topic_id) 
                LEFT JOIN ' . FORUMS_TABLE . ' f ON (t.forum_id = f.forum_id OR (t.topic_type = ' . POST_GLOBAL . ' AND f.forum_type = ' . FORUM_POST . '))
                LEFT JOIN ' . USERS_TABLE . ' u ON (p.poster_id = u.user_id)' . "
                WHERE p.post_id = " . $postId; $result = $db->sql_query_limit($sql, 1); $post_data = $db->sql_fetchrow($result); $db->sql_freeresult($result); if (!$post_data) { TIFunctions::generateError('POST_NOT_EXISTS'); } if (empty($postTitle)) { $postTitle = $post_data['post_subject']; } $forumId = $post_data['forum_id']; $topicId = $post_data['topic_id']; $postId = $postId; if (isset($post_data['poster_id']) && $post_data['poster_id'] == ANONYMOUS) { $post_data['quote_username'] = (!empty($post_data['post_username'])) ? $post_data['post_username'] : $user->lang['GUEST']; } else { $post_data['quote_username'] = isset($post_data['username']) ? $post_data['username'] : ''; } $post_data['post_edit_locked'] = (isset($post_data['post_edit_locked'])) ? (int)$post_data['post_edit_locked'] : 0; $post_data['post_subject'] = (in_array($mode, array('quote', 'edit'))) ? $post_data['post_subject'] : ((isset($post_data['topic_title'])) ? $post_data['topic_title'] : ''); $post_data['topic_time_limit'] = (isset($post_data['topic_time_limit'])) ? (($post_data['topic_time_limit']) ? (int)$post_data['topic_time_limit'] / 86400 : (int)$post_data['topic_time_limit']) : 0; $post_data['poll_length'] = (!empty($post_data['poll_length'])) ? (int)$post_data['poll_length'] / 86400 : 0; $post_data['poll_start'] = (!empty($post_data['poll_start'])) ? (int)$post_data['poll_start'] : 0; $post_data['icon_id'] = (!isset($post_data['icon_id']) || in_array($mode, array('quote', 'reply'))) ? 0 : (int)$post_data['icon_id']; $post_data['poll_options'] = array(); if ($post_data['poll_start']) { $sql = 'SELECT poll_option_text FROM ' . POLL_OPTIONS_TABLE . " WHERE topic_id = " . $topicId . " ORDER BY poll_option_id"; $result = $db->sql_query($sql); while ($row = $db->sql_fetchrow($result)) { $post_data['poll_options'][] = trim($row['poll_option_text']); } $db->sql_freeresult($result); } $message_parser = new parse_message(); if (isset($post_data['post_text'])) { $message_parser->message = &$post_data['post_text']; unset($post_data['post_text']); } $uninit = array( 'post_attachment' => 0, 'poster_id' => $user->data['user_id'], 'enable_magic_url' => 0, 'topic_status' => 0, 'topic_type' => POST_NORMAL, 'post_subject' => '', 'topic_title' => '', 'post_time' => 0, 'post_edit_reason' => '', 'notify_set' => 0 ); foreach ($uninit as $var_name => $default_value) { if (!isset($post_data[$var_name])) { $post_data[$var_name] = $default_value; } } unset($uninit); $message_parser->get_submitted_attachment_data($post_data['poster_id']); if ($post_data['post_attachment'] && !$refresh && !$preview && $mode == 'edit') { $sql = 'SELECT attach_id, is_orphan, attach_comment, real_filename
                    FROM ' . ATTACHMENTS_TABLE . "
                    WHERE post_msg_id = " . $postId . "
                    AND in_message = 0
                    AND is_orphan = 0
                    ORDER BY filetime DESC"; $result = $db->sql_query($sql); $message_parser->attachment_data = array_merge($message_parser->attachment_data, $db->sql_fetchrowset($result)); $db->sql_freeresult($result); } if ($post_data['poster_id'] == ANONYMOUS) { $post_data['username'] = ($mode == 'quote' || $mode == 'edit') ? trim($post_data['post_username']) : ''; } else { $post_data['username'] = ($mode == 'quote' || $mode == 'edit') ? trim($post_data['username']) : ''; } $post_data['enable_urls'] = $post_data['enable_magic_url']; $post_data['enable_magic_url'] = $post_data['drafts'] = false; $check_value = (($post_data['enable_bbcode']+1) << 8) + (($post_data['enable_smilies']+1) << 4) + (($post_data['enable_urls']+1) << 2) + (($post_data['enable_sig']+1) << 1); if ($post_data['bbcode_uid']) { $message_parser->bbcode_uid = $post_data['bbcode_uid']; } $bbcode_status = ($config['allow_bbcode'] && $auth->acl_get('f_bbcode', $forumId)) ? true : false; $smilies_status = ($bbcode_status && $config['allow_smilies'] && $auth->acl_get('f_smilies', $forumId)) ? true : false; $img_status = ($bbcode_status && $auth->acl_get('f_img', $forumId)) ? true : false; $url_status = ($config['allow_post_links']) ? true : false; $flash_status = ($bbcode_status && $auth->acl_get('f_flash', $forumId) && $config['allow_post_flash']) ? true : false; $quote_status = ($auth->acl_get('f_reply', $forumId)) ? true : false; $post_data['topic_cur_post_id'] = request_var('topic_cur_post_id', 0); $post_data['post_subject'] = utf8_normalize_nfc($postTitle); $message_parser->message = utf8_normalize_nfc(htmlspecialchars($postContent)); $post_data['username'] = utf8_normalize_nfc(request_var('username', $post_data['username'], true)); $post_data['post_edit_reason'] = (!empty($reason) && $mode == 'edit' && $auth->acl_get('m_edit', $forumId)) ? utf8_normalize_nfc($reason) : ''; $post_data['orig_topic_type'] = $post_data['topic_type']; $post_data['topic_type'] = request_var('topic_type', (($mode != 'post') ? (int)$post_data['topic_type'] : POST_NORMAL)); $post_data['topic_time_limit'] = request_var('topic_time_limit', (($mode != 'post') ? (int)$post_data['topic_time_limit'] : 0)); $post_data['icon_id'] = request_var('icon', 0); $post_data['enable_bbcode'] = (!$bbcode_status || isset($_POST['disable_bbcode'])) ? false : true; $post_data['enable_smilies'] = (!$smilies_status || isset($_POST['disable_smilies'])) ? false : true; $post_data['enable_urls'] = (isset($_POST['disable_magic_url'])) ? 0 : 1; $post_data['enable_sig'] = (!$config['allow_sig'] || !$auth->acl_get('f_sigs', $forumId) || !$auth->acl_get('u_sig')) ? false : ($user->data['is_registered'] ? true : false); if ($config['allow_topic_notify'] && $user->data['is_registered']) { $notify = (isset($_POST['notify'])) ? true : false; } else { $notify = false; } $topic_lock = (isset($_POST['lock_topic'])) ? true : $post_data['topic_status']; $post_lock = (isset($_POST['lock_post'])) ? true : $post_data['post_edit_locked']; $poll_delete = (isset($_POST['poll_delete'])) ? true : false; $status_switch = (($post_data['enable_bbcode']+1) << 8) + (($post_data['enable_smilies']+1) << 4) + (($post_data['enable_urls']+1) << 2) + (($post_data['enable_sig']+1) << 1); $status_switch = ($status_switch != $check_value); $post_data['poll_option_text'] = implode("\n", $post_data['poll_options']); $message_parser->parse_attachments('fileupload', $mode, $forumId, $submit, $preview, $refresh); $message_md5 = md5($message_parser->message); $update_message = ($mode != 'edit' || $message_md5 != $post_data['post_checksum'] || $status_switch || strlen($post_data['bbcode_uid']) < BBCODE_UID_LEN) ? true : false; if ($update_message) { if (!empty($message_parser->warn_msg)) { TIFunctions::generateError(implode("\n", $message_parser->warn_msg)); } $message_parser->parse($post_data['enable_bbcode'], ($config['allow_post_links']) ? $post_data['enable_urls'] : false, $post_data['enable_smilies'], $img_status, $flash_status, $quote_status, $config['allow_post_links']); } else { $message_parser->bbcode_bitfield = $post_data['bbcode_bitfield']; } if (($post_data['username'] && !$user->data['is_registered']) || ($mode == 'edit' && $post_data['poster_id'] == ANONYMOUS && $post_data['username'] && $post_data['post_username'] && $post_data['post_username'] != $post_data['username'])) { include $phpbb_root_path . 'includes/functions_user.' . $phpEx; if (($result = validate_username($post_data['username'], (!empty($post_data['post_username'])) ? $post_data['post_username'] : '')) !== false) { $user->add_lang('ucp'); TIFunctions::generateError($result . '_USERNAME'); } } if (utf8_clean_string($post_data['post_subject']) === '' && $post_data['topic_first_post_id'] == $postId) { TIFunctions::generateError('POST_EMPTY_SUBJECT'); } $post_data['poll_last_vote'] = (isset($post_data['poll_last_vote'])) ? $post_data['poll_last_vote'] : 0; if ($post_data['poll_option_text'] && $postId == $post_data['topic_first_post_id'] && $auth->acl_get('f_poll', $forumId)) { $poll = array( 'poll_title' => $post_data['poll_title'], 'poll_length' => $post_data['poll_length'], 'poll_max_options' => $post_data['poll_max_options'], 'poll_option_text' => $post_data['poll_option_text'], 'poll_start' => $post_data['poll_start'], 'poll_last_vote' => $post_data['poll_last_vote'], 'poll_vote_change' => $post_data['poll_vote_change'], 'enable_bbcode' => $post_data['enable_bbcode'], 'enable_urls' => $post_data['enable_urls'], 'enable_smilies' => $post_data['enable_smilies'], 'img_status' => $img_status ); $message_parser->parse_poll($poll); $post_data['poll_options'] = (isset($poll['poll_options'])) ? $poll['poll_options'] : ''; $post_data['poll_title'] = (isset($poll['poll_title'])) ? $poll['poll_title'] : ''; } else { $poll = array(); } if ($post_data['topic_type'] != POST_NORMAL && $post_data['topic_first_post_id'] == $postId) { switch ($post_data['topic_type']) { case POST_GLOBAL: case POST_ANNOUNCE: $auth_option = 'f_announce'; break; case POST_STICKY: $auth_option = 'f_sticky'; break; default: $auth_option = ''; break; } if (!$auth->acl_get($auth_option, $forumId)) { $post_data['topic_type'] = $post_data['orig_topic_type']; } } if ($post_data['topic_type'] != POST_GLOBAL) { $sql = 'SELECT topic_type, forum_id FROM ' . TOPICS_TABLE . " WHERE topic_id = " . $topicId; $result = $db->sql_query($sql); $row = $db->sql_fetchrow($result); $db->sql_freeresult($result); if ($row && !$row['forum_id'] && $row['topic_type'] == POST_GLOBAL) { $to_forum_id = request_var('to_forum_id', 0); if ($to_forum_id) { $sql = 'SELECT forum_type FROM ' . FORUMS_TABLE . ' WHERE forum_id = ' . $to_forum_id; $result = $db->sql_query($sql); $forum_type = (int)$db->sql_fetchfield('forum_type'); $db->sql_freeresult($result); if ($forum_type != FORUM_POST || !$auth->acl_get('f_post', $to_forum_id)) { $to_forum_id = 0; } } if (!$to_forum_id) { include_once $phpbb_root_path . 'includes/functions_admin.' . $phpEx; $template->assign_vars(array( 'S_FORUM_SELECT' => make_forum_select(false, false, false, true, true, true), 'S_UNGLOBALISE' => true) ); } else { if (!$auth->acl_get('f_post', $to_forum_id)) { TIFunctions::generateError('GENERAL_DENIED'); } $forumId = $to_forum_id; } } } $change_topic_status = $post_data['topic_status']; $perm_lock_unlock = ($auth->acl_get('m_lock', $forumId) || ($auth->acl_get('f_user_lock', $forumId) && $user->data['is_registered'] && !empty($post_data['topic_poster']) && $user->data['user_id'] == $post_data['topic_poster'] && $post_data['topic_status'] == ITEM_UNLOCKED)) ? true : false; if ($post_data['topic_status'] == ITEM_LOCKED && !$topic_lock && $perm_lock_unlock) { $change_topic_status = ITEM_UNLOCKED; } elseif ($post_data['topic_status'] == ITEM_UNLOCKED && $topic_lock && $perm_lock_unlock) { $change_topic_status = ITEM_LOCKED; } if ($change_topic_status != $post_data['topic_status']) { $sql = 'UPDATE ' . TOPICS_TABLE . " SET topic_status = " . $change_topic_status . " WHERE topic_id = " . $topicId . " AND topic_moved_id = 0"; $db->sql_query($sql); $user_lock = ($auth->acl_get('f_user_lock', $forumId) && $user->data['is_registered'] && $user->data['user_id'] == $post_data['topic_poster']) ? 'USER_' : ''; add_log('mod', $forumId, $topicId, 'LOG_' . $user_lock . (($change_topic_status == ITEM_LOCKED) ? 'LOCK' : 'UNLOCK'), $post_data['topic_title']); } if ($mode == 'edit' && $post_data['post_edit_locked'] == ITEM_LOCKED && !$post_lock && $auth->acl_get('m_edit', $forumId)) { $post_data['post_edit_locked'] = ITEM_UNLOCKED; } elseif($mode == 'edit' && $post_data['post_edit_locked'] == ITEM_UNLOCKED && $post_lock && $auth->acl_get('m_edit', $forumId)) { $post_data['post_edit_locked'] = ITEM_LOCKED; } $data = array( 'topic_title' => (empty($post_data['topic_title'])) ? $post_data['post_subject'] : $post_data['topic_title'], 'topic_first_post_id' => (isset($post_data['topic_first_post_id'])) ? (int)$post_data['topic_first_post_id'] : 0, 'topic_last_post_id' => (isset($post_data['topic_last_post_id'])) ? (int)$post_data['topic_last_post_id'] : 0, 'topic_time_limit' => (int)$post_data['topic_time_limit'], 'topic_attachment' => (isset($post_data['topic_attachment'])) ? (int)$post_data['topic_attachment'] : 0, 'post_id' => (int)$postId, 'topic_id' => (int)$topicId, 'forum_id' => (int)$forumId, 'icon_id' => (int)$post_data['icon_id'], 'poster_id' => (int)$post_data['poster_id'], 'enable_sig' => (bool)$post_data['enable_sig'], 'enable_bbcode' => (bool)$post_data['enable_bbcode'], 'enable_smilies' => (bool)$post_data['enable_smilies'], 'enable_urls' => (bool)$post_data['enable_urls'], 'enable_indexing' => (bool)$post_data['enable_indexing'], 'message_md5' => (string)$message_md5, 'post_time' => (isset($post_data['post_time'])) ? (int)$post_data['post_time'] : time(), 'post_checksum' => (isset($post_data['post_checksum'])) ? (string)$post_data['post_checksum'] : '', 'post_edit_reason' => $post_data['post_edit_reason'], 'post_edit_user' => ($mode == 'edit') ? $user->data['user_id'] : ((isset($post_data['post_edit_user'])) ? (int)$post_data['post_edit_user'] : 0), 'forum_parents' => $post_data['forum_parents'], 'forum_name' => $post_data['forum_name'], 'notify' => $notify, 'poster_ip' => (isset($post_data['poster_ip'])) ? $post_data['poster_ip'] : $user->ip, 'post_edit_locked' => (int)$post_data['post_edit_locked'], 'bbcode_bitfield' => $message_parser->bbcode_bitfield, 'bbcode_uid' => $message_parser->bbcode_uid, 'message' => $message_parser->message, 'attachment_data' => $message_parser->attachment_data, 'filename_data' => $message_parser->filename_data, 'topic_approved' => (isset($post_data['topic_approved'])) ? $post_data['topic_approved'] : false, 'post_approved' => (isset($post_data['post_approved'])) ? $post_data['post_approved'] : false, ); $data['topic_replies_real'] = $post_data['topic_replies_real']; $data['topic_replies'] = $post_data['topic_replies']; include $phpbb_root_path . 'includes/functions_posting.' . $phpEx; submit_post($mode, $post_data['post_subject'], $post_data['username'], $post_data['topic_type'], $poll, $data, $update_message); $approved = true; if ((($config['enable_queue_trigger'] && $user->data['user_posts'] < $config['queue_trigger_posts']) || !$auth->acl_get('f_noapprove', $data['forum_id'])) && !$auth->acl_get('m_approve', $data['forum_id'])) { $approved = false; } return array( 'state' => !$approved ? true : null, 'content' => $data['message'], ); } public static function post($in, $topic = null, $forum = null) { global $db, $auth, $user, $config, $phpbb_root_path, $phpEx, $request; $forumId = $in['forumId']; $topicId = isset($in['topicId']) ? $in['topicId'] : null; $subject = $in['subject']; $content = \Emojione\Emojione::getClient()->toShort($in['body']); $subject = preg_replace(\Emojione\Emojione::getClient()->unicodeRegexp, '', $subject); $attachmentIds = !empty($in['attachmentIds']) ? $in['attachmentIds'] : array(); $groupId = !empty($in['groupId']) ? unserialize(base64_decode($in['groupId'])) : array(); $returnHtml = isset($in['html']) ? $in['html'] : null; $user->setup('posting'); $request->overwrite('attachment_data', $attachmentIds, \phpbb\request\request_interface::POST); if (utf8_clean_string($content) === '') { TIFunctions::generateError('POST_TOO_FEW_CHARS'); } if ($config['topicit_add_sig']) { $content .= "\n\n" . $user->lang['PLUG_TOPICIT_SENT_FROM_APP']; } $post_data = array(); $current_time = time(); if (!is_null($topic)) { $post_data = array_merge($topic->bind, $forum->bind); } $subject = !is_null($topic) ? (((strpos($subject, 'Re: ') !== 0) ? 'Re: ' : '') . ($subject ? $subject : censor_text($post_data['topic_title']))) : $subject; $post_data['quote_username'] = ''; $post_data['post_edit_locked'] = (isset($post_data['post_edit_locked'])) ? (int)$post_data['post_edit_locked'] : 0; $post_data['post_subject'] = (isset($post_data['topic_title'])) ? $post_data['topic_title'] : ''; $post_data['topic_time_limit'] = (isset($post_data['topic_time_limit'])) ? (($post_data['topic_time_limit']) ? (int)$post_data['topic_time_limit'] / 86400 : (int)$post_data['topic_time_limit']) : 0; $post_data['poll_length'] = (!empty($post_data['poll_length'])) ? (int)$post_data['poll_length'] / 86400 : 0; $post_data['poll_start'] = (!empty($post_data['poll_start'])) ? (int)$post_data['poll_start'] : 0; $post_data['icon_id'] = 0; $post_data['poll_options'] = array(); if ($post_data['poll_start']) { $sql = 'SELECT poll_option_text FROM ' . POLL_OPTIONS_TABLE . " WHERE topic_id = " . $topicId . " ORDER BY poll_option_id"; $result = $db->sql_query($sql); while ($row = $db->sql_fetchrow($result)) { $post_data['poll_options'][] = trim($row['poll_option_text']); } $db->sql_freeresult($result); } $orig_poll_options_size = sizeof($post_data['poll_options']); include $phpbb_root_path . 'includes/message_parser.' . $phpEx; $message_parser = new parse_message(); $uninit = array( 'post_attachment' => 0, 'poster_id' => $user->data['user_id'], 'enable_magic_url' => 0, 'topic_status' => 0, 'topic_type' => POST_NORMAL, 'post_subject' => '', 'topic_title' => '', 'post_time' => 0, 'post_edit_reason' => '', 'notify_set' => 0 ); foreach ($uninit as $var_name => $default_value) { if (!isset($post_data[$var_name])) { $post_data[$var_name] = $default_value; } } unset($uninit); $notify = false; if ($config['allow_topic_notify'] && $user->data['is_registered']) { $notify = $topic->isSubscribed; } $message_parser->get_submitted_attachment_data($post_data['poster_id']); $post_data['username'] = ''; $post_data['enable_urls'] = $post_data['enable_magic_url']; $post_data['enable_sig'] = ($config['allow_sig'] && $user->optionget('attachsig')) ? true: false; $post_data['enable_smilies'] = ($config['allow_smilies'] && $user->optionget('smilies')) ? true : false; $post_data['enable_bbcode'] = ($config['allow_bbcode'] && $user->optionget('bbcode')) ? true : false; $post_data['enable_urls'] = true; $post_data['enable_magic_url'] = $post_data['drafts'] = false; $check_value = (($post_data['enable_bbcode']+1) << 8) + (($post_data['enable_smilies']+1) << 4) + (($post_data['enable_urls']+1) << 2) + (($post_data['enable_sig']+1) << 1); if (!is_null($topic) && $config['allow_topic_notify'] && $user->data['is_registered']) { $sql = 'SELECT topic_id FROM ' . TOPICS_WATCH_TABLE . ' WHERE topic_id = ' . $topicId . ' AND user_id = ' . $user->data['user_id']; $result = $db->sql_query($sql); $post_data['notify_set'] = (int)$db->sql_fetchfield('topic_id'); $db->sql_freeresult($result); } $bbcode_status = ($config['allow_bbcode'] && $auth->acl_get('f_bbcode', $forumId)) ? true : false; $smilies_status = ($bbcode_status && $config['allow_smilies'] && $auth->acl_get('f_smilies', $forumId)) ? true : false; $img_status = ($bbcode_status && $auth->acl_get('f_img', $forumId)) ? true : false; $url_status = ($config['allow_post_links']) ? true : false; $flash_status = ($bbcode_status && $auth->acl_get('f_flash', $forumId) && $config['allow_post_flash']) ? true : false; $quote_status = ($auth->acl_get('f_reply', $forumId)) ? true : false; $post_data['topic_cur_post_id'] = request_var('topic_cur_post_id', 0); $post_data['post_subject'] = utf8_normalize_nfc($subject); $message_parser->message = utf8_normalize_nfc(htmlspecialchars($content)); $post_data['username'] = utf8_normalize_nfc(request_var('username', $post_data['username'], true)); $post_data['post_edit_reason'] = ''; $post_data['orig_topic_type'] = $post_data['topic_type']; $post_data['topic_type'] = request_var('topic_type', (!is_null($topic) ? $post_data['topic_type'] : POST_NORMAL)); $post_data['topic_time_limit'] = request_var('topic_time_limit', (!is_null($topic) ? $post_data['topic_time_limit'] : 0)); $post_data['icon_id'] = request_var('icon', 0); $post_data['enable_bbcode'] = (!$bbcode_status || isset($_POST['disable_bbcode'])) ? false : true; $post_data['enable_smilies'] = (!$smilies_status || isset($_POST['disable_smilies'])) ? false : true; $post_data['enable_urls'] = (isset($_POST['disable_magic_url'])) ? 0 : 1; $post_data['enable_sig'] = (!$config['allow_sig'] || !$auth->acl_get('f_sigs', $forumId) || !$auth->acl_get('u_sig')) ? false : ($user->data['is_registered'] ? true : false); $topic_lock = (isset($_POST['lock_topic'])) ? true : false; $post_lock = (isset($_POST['lock_post'])) ? true : false; $poll_delete = (isset($_POST['poll_delete'])) ? true : false; $status_switch = (($post_data['enable_bbcode']+1) << 8) + (($post_data['enable_smilies']+1) << 4) + (($post_data['enable_urls']+1) << 2) + (($post_data['enable_sig']+1) << 1); $status_switch = ($status_switch != $check_value); $post_data['poll_title'] = utf8_normalize_nfc(request_var('poll_title', '', true)); $post_data['poll_length'] = request_var('poll_length', 0); $post_data['poll_option_text'] = utf8_normalize_nfc(request_var('poll_option_text', '', true)); $post_data['poll_max_options'] = request_var('poll_max_options', 1); $post_data['poll_vote_change'] = ($auth->acl_get('f_votechg', $forumId) && isset($_POST['poll_vote_change'])) ? 1 : 0; $message_parser->parse_attachments('fileupload', (!is_null($topic) ? 'relpy' : 'post'), $forumId, true, false, false); $message_md5 = md5($message_parser->message); if (!empty($message_parser->warn_msg)) { TIFunctions::generateError(implode("\n", $message_parser->warn_msg)); } $message_parser->parse($post_data['enable_bbcode'], ($config['allow_post_links']) ? $post_data['enable_urls'] : false, $post_data['enable_smilies'], $img_status, $flash_status, $quote_status, $config['allow_post_links']); if ($config['flood_interval'] && !$auth->acl_get('f_ignoreflood', $forumId)) { $last_post_time = 0; if ($user->data['is_registered']) { $last_post_time = $user->data['user_lastpost_time']; } else { $sql = 'SELECT post_time AS last_post_time FROM ' . POSTS_TABLE . " WHERE poster_ip = '" . $user->ip . "' AND post_time > " . ($current_time - $config['flood_interval']); $result = $db->sql_query_limit($sql, 1); if ($row = $db->sql_fetchrow($result)) { $last_post_time = $row['last_post_time']; } $db->sql_freeresult($result); } if ($last_post_time && ($current_time - $last_post_time) < intval($config['flood_interval'])) { TIFunctions::generateError('POST_FLOOD_ERROR'); } } if (($post_data['username'] && !$user->data['is_registered'])) { include $phpbb_root_path . 'includes/functions_user.' . $phpEx; if (($result = validate_username($post_data['username'], (!empty($post_data['post_username'])) ? $post_data['post_username'] : '')) !== false) { $user->add_lang('ucp'); TIFunctions::generateError($result . '_USERNAME'); } } if (!empty($message_parser->warn_msg)) { TIFunctions::generateError(implode("\n", $message_parser->warn_msg)); } $post_data['poll_last_vote'] = (isset($post_data['poll_last_vote'])) ? $post_data['poll_last_vote'] : 0; $poll = array(); $data = array( 'topic_title' => (empty($post_data['topic_title'])) ? $post_data['post_subject'] : $post_data['topic_title'], 'topic_first_post_id' => (isset($post_data['topic_first_post_id'])) ? (int)$post_data['topic_first_post_id'] : 0, 'topic_last_post_id' => (isset($post_data['topic_last_post_id'])) ? (int)$post_data['topic_last_post_id'] : 0, 'topic_time_limit' => (int)$post_data['topic_time_limit'], 'topic_attachment' => (isset($post_data['topic_attachment'])) ? (int)$post_data['topic_attachment'] : 0, 'post_id' => 0, 'topic_id' => !is_null($topic) ? $topicId : 0, 'forum_id' => (int)$forumId, 'icon_id' => (int)$post_data['icon_id'], 'poster_id' => (int)$post_data['poster_id'], 'enable_sig' => (bool)$post_data['enable_sig'], 'enable_bbcode' => (bool)$post_data['enable_bbcode'], 'enable_smilies' => (bool)$post_data['enable_smilies'], 'enable_urls' => (bool)$post_data['enable_urls'], 'enable_indexing' => (bool)$post_data['enable_indexing'], 'message_md5' => (string)$message_md5, 'post_time' => (isset($post_data['post_time'])) ? (int)$post_data['post_time'] : $current_time, 'post_checksum' => (isset($post_data['post_checksum'])) ? (string)$post_data['post_checksum'] : '', 'post_edit_reason' => $post_data['post_edit_reason'], 'post_edit_user' => (isset($post_data['post_edit_user'])) ? (int)$post_data['post_edit_user'] : 0, 'forum_parents' => $post_data['forum_parents'], 'forum_name' => $post_data['forum_name'], 'notify' => $notify, 'notify_set' => $post_data['notify_set'], 'poster_ip' => (isset($post_data['poster_ip'])) ? $post_data['poster_ip'] : $user->ip, 'post_edit_locked' => (int)$post_data['post_edit_locked'], 'bbcode_bitfield' => $message_parser->bbcode_bitfield, 'bbcode_uid' => $message_parser->bbcode_uid, 'message' => $message_parser->message, 'attachment_data' => $message_parser->attachment_data, 'filename_data' => $message_parser->filename_data, 'topic_approved' => (isset($post_data['topic_approved'])) ? $post_data['topic_approved'] : false, 'post_approved' => (isset($post_data['post_approved'])) ? $post_data['post_approved'] : false, 'post_expire_time' => -1, 'topic_status' => 0, ); include $phpbb_root_path . 'includes/functions_posting.' . $phpEx; preg_match_all('/quote=&quot;(.*?)&quot;/is', $data['message'], $quote_matches); if (!empty($quote_matches['1'])) { $mode = 'quote'; } elseif(!is_null($topic)) { $mode = 'reply'; } else { $mode = 'post'; } submit_post($mode, $post_data['post_subject'], $post_data['username'], $post_data['topic_type'], $poll, $data, true); return $data; } public static function getByUnread($topicId, $in) { $perPage = !empty($in['limit']) ? $in['limit'] : 20; $html = !empty($in['html']) ? $in['html'] : false; if (!$topic = TopicModel::getTopicById($topicId)) { TIFunctions::generateError('TOPIC_NOT_EXISTS'); } $topic->setFirstUnreadPosition(); UserFunctions::checkAuth(array('f_read', $topic->forumId)); $page = ceil($topic->firstUnreadPosition / $perPage); $page = $page > 0 ? $page : 1; $start = ($page - 1) * $perPage; $limit = $start + $perPage - 1; $posts = self::getPosts($topic->topicId , $start, $limit, $html); return array( 'position' => $topic->firstUnreadPosition, 'topic' => $topic, 'posts' => $posts ); } public static function getByPost($postId, $in) { global $db, $user; $perPage = !empty($in['limit']) ? $in['limit'] : 20; $html = !empty($in['html']) ? $in['html'] : false; if (!$post = self::getPost($postId)) { TIFunctions::generateError('POST_NOT_EXISTS'); } UserFunctions::checkAuth(array('f_read', $post->forumId)); $page = ceil($post->position / $perPage); $page = $page > 0 ? $page : 1; $start = ($page - 1) * $perPage; $limit = $start + $perPage - 1; $posts = self::getPosts($post->topicId , $start, $limit, $html); return array( 'position' => $post->position, 'topic' => $post->getTopic(), 'posts' => $posts ); } private static function checkAclReplyPost($forum, $topic) { global $user,$auth; if (!$user->data['is_registered']) { TIFunctions::generateError('POST_LOGIN_EXPLAIN'); } if ($forum->isProtected && !check_forum_password($forum->forumId)) { TIFunctions::generateError('FORUM_LOGIN_VIEWFORUM'); } if ($user->data['is_bot']) { TIFunctions::generateError('GENERAL_DENIED'); } if (!$auth->acl_get('f_read', $forum->forumId)) { if ($user->data['user_id'] != ANONYMOUS) { TIFunctions::generateError('USER_CANNOT_READ'); } TIFunctions::generateError('LOGIN_EXPLAIN_POST'); } if (!$auth->acl_get('f_reply', $forum->forumId)) { if ($user->data['user_id'] != ANONYMOUS) { TIFunctions::generateError('USER_CANNOT_REPLY'); } TIFunctions::generateError('LOGIN_EXPLAIN_POST'); } if ($forum->forumType != FORUM_POST) { TIFunctions::generateError('USER_CANNOT_FORUM_POST'); } if (($forum->state == ITEM_LOCKED || ($topic->state == ITEM_LOCKED)) && !$auth->acl_get('m_edit', $forum->forumId)) { TIFunctions::generateError(($forum->state == ITEM_LOCKED) ? 'Forum_locked' : 'Topic_locked'); } return true; } private static function checkAclGetPost($post, $edit = false) { global $auth, $user, $config; $forumId = $post->forumId; $post_data = $post->bind; if (!$auth->acl_get('f_read', $forumId)) { TIFunctions::generateError('USER_CANNOT_READ'); } if (!($user->data['is_registered'] && $auth->acl_gets('f_edit', 'm_edit', $forumId))) { TIFunctions::generateError('USER_CANNOT_EDIT'); } if (($post_data['forum_status'] == ITEM_LOCKED || (isset($post_data['topic_status']) && $post_data['topic_status'] == ITEM_LOCKED)) && !$auth->acl_get('m_edit', $forumId)) { TIFunctions::generateError(($post_data['forum_status'] == ITEM_LOCKED) ? 'Forum_locked' : 'Topic_locked'); } if ($edit && !$auth->acl_get('m_edit', $forumId)) { if ($user->data['user_id'] != $post_data['poster_id']) { TIFunctions::generateError('USER_CANNOT_EDIT'); } if (!($post_data['post_time'] > time() - ($config['edit_time'] * 60) || !$config['edit_time'])) { TIFunctions::generateError('USER_CANNOT_EDIT_TIME'); } if ($post_data['post_edit_locked']) { TIFunctions::generateError('USER_CANNOT_EDIT_POST_LOCKED'); } } return true; } private static function checkAclGetQuotePost($post) { global $user,$auth; $forum = ForumModel::getForumById($post->forumId); $topic = TopicModel::getTopicById($post->topicId); if (!$user->data['is_registered']) { TIFunctions::generateError('LOGIN_EXPLAIN_POST'); } if ($forum->isProtected && !check_forum_password($forum->forumId)) { TIFunctions::generateError('LOGIN_FORUM'); } if (!$auth->acl_get('f_read', $post->forumId)) { TIFunctions::generateError('USER_CANNOT_READ'); } if (!$auth->acl_get('f_reply', $post->forumId)) { TIFunctions::generateError('USER_CANNOT_REPLY'); } if ($forum->forumType != FORUM_POST) { TIFunctions::generateError('USER_CANNOT_FORUM_POST'); } if (($forum->forumType == ITEM_LOCKED || ($topic->state == ITEM_LOCKED)) && !$auth->acl_get('m_edit', $post->forumId)) { TIFunctions::generateError(($forum->state == ITEM_LOCKED) ? 'Forum_locked' : 'Topic_locked'); } return true; } public static function getPostContent($postId) { global $db; if (empty($postId)) return ''; $sql = 'SELECT post_text FROM ' . POSTS_TABLE . ' WHERE post_id = ' . $postId; $result = $db->sql_query($sql); $post_text = $db->sql_fetchfield('post_text'); $db->sql_freeresult($result); return $post_text; } } 