<?php
 final class TopicController implements TopicInterface { public static function getTopics($forumId, $start, $limit, $mode) { global $db, $user, $auth; UserFunctions::checkAuth(array('f_read', $forumId)); UserFunctions::checkAuth(array('f_list', 'f_read', $forumId)); $forum = ForumModel::getForumById($forumId); $user->setup('viewforum'); list($start, $limit) = MiscFunctions::pagination($start, $limit); $sort = 't.topic_last_post_time DESC'; $topicType = ''; if ($mode == 'TOP') { $topicType = POST_STICKY; $start = 0; $limit = 20; } elseif($mode == 'ANN') { $topicType = POST_ANNOUNCE . ', ' . POST_GLOBAL; $start = 0; $limit = 20; } if ($forum->isProtected && !MiscFunctions::checkForumPassword($forumId)) { TIFunctions::generateError('FORUM_LOGIN_VIEWFORUM'); } $sqlApprove = $auth->acl_get('m_approve', $forumId) ? '' : ' AND t.topic_visibility = 1 '; $movedTopics = ForumController::getMovedTopics($forumId); $sqlMovedTopics = empty($movedTopics) ? '' : 'AND ' . $db->sql_in_set('t.topic_moved_id', $movedTopics, true); if (!empty($topicType)) { $sql = 'SELECT t.*, u.user_avatar, u.user_avatar_type,bm.topic_id as bookmarked 
                    FROM ' . TOPICS_TABLE . ' t 
                    LEFT JOIN ' . USERS_TABLE . ' u ON (t.topic_poster = u.user_id) 
                    LEFT JOIN ' . BOOKMARKS_TABLE . ' bm ON (bm.user_id = ' . $user->data['user_id'] . ' AND t.topic_id = bm.topic_id) 
                    WHERE t.forum_id IN (' . $forumId . ', 0) AND t.topic_type IN (' . $topicType . ') ' . $sqlMovedTopics . ' ' . $sqlApprove . ' ORDER BY ' . $sort; $result = $db->sql_query_limit($sql, $limit, $start); } else { $sql = 'SELECT t.*, u.user_avatar, u.user_avatar_type,bm.topic_id as bookmarked, pt.post_text
                    FROM ' . TOPICS_TABLE . ' t
                    LEFT JOIN ' . USERS_TABLE . ' u ON (t.topic_poster = u.user_id)
                    LEFT JOIN ' . BOOKMARKS_TABLE . ' bm ON (bm.user_id = ' . $user->data['user_id'] . ' AND t.topic_id = bm.topic_id) 
                    LEFT JOIN ' . POSTS_TABLE . ' pt ON (pt.post_id = t.topic_last_post_id) 
                    WHERE t.forum_id = ' . $forumId.' AND t.topic_type = ' . POST_NORMAL . ' ' . $sqlMovedTopics . ' ' . $sqlApprove . ' ORDER BY ' . $sort; $result = $db->sql_query_limit($sql, $limit, $start); } $topics = array(); while ($row = $db->sql_fetchrow($result)) { $topics[] = new TopicModel($row); } return $topics; } public static function newTopic($in) { self::checkAclNewTopic($in['forumId']); $topic = PostController::post($in); return $topic; } public static function markRead($topicIds) { foreach ($topicIds as $topicId) { $topic = TopicModel::getTopicById($topicId); $forum = $topic->getForum(); markread('topic', $topic->forumId, $topic->topicId); update_forum_tracking_info($topic->forumId, $forum->lastPostTime, false, false); } return true; } public static function getTopicsByIdList($idList) { global $auth; $topics = TopicModel::getTopicsByIds($idList); foreach ($topics as $k => $topic) { if (!$auth->acl_get('f_read', $topic->forumId)) { unset($topics[$k]); } } return $topics; } private static function checkAclNewTopic($forumId) { global $auth, $user; $forum = ForumModel::getForumById($forumId); $user->setup('posting'); if (!$user->data['is_registered']) { TIFunctions::generateError('POST_LOGIN_EXPLAIN'); } if ($forum->isProtected && !check_forum_password($forum->forumId)) { TIFunctions::generateError('FORUM_LOGIN_VIEWFORUM'); } if ($user->data['is_bot']) { TIFunctions::generateError('GENERAL_DENIED'); } if (!$auth->acl_get('f_read', $forum->forumId)) { if ($user->data['user_id'] != ANONYMOUS) { TIFunctions::generateError('USER_CANNOT_READ'); } TIFunctions::generateError('POST_LOGIN_EXPLAIN'); } if (!$auth->acl_get('f_post', $forum->forumId)) { if ($user->data['user_id'] != ANONYMOUS) { TIFunctions::generateError('USER_CANNOT_POST'); } TIFunctions::generateError('POST_LOGIN_EXPLAIN'); } if ($forum->forumType != FORUM_POST) { TIFunctions::generateError('USER_CANNOT_FORUM_POST'); } if ($forum->state == ITEM_LOCKED && !$auth->acl_get('m_edit', $forum->forumId)) { TIFunctions::generateError('FORUM_LOCKED'); } return true; } public static function getFollowed($start, $limit) { } } 