<?php
 final class UserController implements UserInterface { public static function getAvatar($id, $by) { UserFunctions::checkAuth('u_chgavatar'); switch ($by) { case 'id': $user = UserModel::getUserById($id); break; default: $user = UserModel::getUserByUsername($id); break; } $protocol = (isset($_SERVER['SERVER_PROTOCOL']) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0'); if ($user) { if (isset($user->iconUrl)) { header("Location: " . generate_board_url() . '/' . $user->iconUrl, 0, 303); die(); } } header($protocol . ' 404 Not Found', true, 404); die(); } public static function getUserInfo($id, $by) { switch($by) { case 'id': return UserModel::getUserById($id); break; default: return UserModel::getUserByUsername($id); break; } } public static function logIn($username, $password, $anonymous, $userkey) { global $auth, $user, $config, $table_prefix,$db; $user->session_kill(); $user->setup('ucp'); if (!$userObj = UserModel::getUserByUsername($username)) { TIFunctions::generateError('USER_USERNAME_NOT_EXISTS'); } $config['ip_login_limit_max'] = false; $config['max_login_attempts'] = false; $login = $auth->login($username, $password, true, !$anonymous); if ($login['status'] == LOGIN_SUCCESS) { self::loginDirectly($userObj); $userObj->setUserKey($userkey, false); return UserFunctions::setTopicitUser($userObj->renew()); } else { TIFunctions::generateError(str_replace('%s', '', strip_tags($user->lang[$login['error_msg']]))); } return true; } public static function loginDirectly($userObj, $verif = array(), $method = 'POST') { global $user, $config, $auth; if ($userObj->userType === 'unapproved') { return 'The specified username is currently inactive or forum require admin approval for new accounts. If you have problems activating your account, please contact a board administrator.'; } $user->session_kill(); $user->setup('ucp'); $config['max_login_attempts'] = 20; $config['ip_login_limit_max'] = 50; $result = $user->session_create($userObj->userId, false, false, 1); $auth->acl($user->data); if ($result === true && !empty($verif)) { $subscribe = UserFunctions::subscribe($verif, $userObj, $method); if (!empty($subscribe)) { return Stream::returnError($subscribe); } } return $result; } public static function logOut() { global $user; $user->session_kill(); } public static function retrievePassword($id, $by) { global $phpbb_root_path, $phpEx, $request; switch ($by) { case 'email': $tiuser = UserModel::getUserByEmail($id); break; case 'id': $tiuser = UserModel::getUserById($id); break; default: $tiuser = UserModel::getUserByUsername($id); break; } if (!$tiuser) { TIFunctions::generateError('USER_NOT_EXISTS'); } App::getInstance()->error(MiscFunctions::errorHandler()); require_once($phpbb_root_path . 'includes/functions_user.' . $phpEx); require_once($phpbb_root_path . 'includes/functions_module.' . $phpEx); $request->overwrite('i', $tiuser->userId); $request->overwrite('mode', 'sendpassword'); $request->overwrite('username', $tiuser->userName); $request->overwrite('email', $tiuser->bind['user_email']); $request->overwrite('submit', true,\phpbb\request\request_interface::POST); $module = new p_master(); $module->load('ucp', 'remind','sendpassword'); } public static function getOnlineUsers($in = array()) { global $config, $db; UserFunctions::checkAuth(array('u_viewprofile')); $page = isset($in['page']) ? $in['page'] : 1; $perpage = isset($in['perpage']) ? $in['perpage'] : 20; $start = ($page - 1) * $perpage; $limit = "LIMIT $start , $perpage"; $reading_sql = ''; if ($in['id'] !== 0) { $reading_sql = ' AND s.session_forum_id = ' . (int)$in['id']; } $onlinetime = time() - ($config['load_online_time'] * 60); $sql = 'SELECT u.*, s.session_time, s.session_viewonline 
                FROM ' . USERS_TABLE . ' u
                JOIN (
                    SELECT u.user_id, MAX(s.session_time) as session_time, MIN(s.session_viewonline) AS session_viewonline
                    FROM ' . USERS_TABLE . ' AS u
                    LEFT JOIN ' . SESSIONS_TABLE .' AS s ON u.user_id = s.session_user_id
                    WHERE u.user_type <> 2 AND session_viewonline = 1 AND session_time > ' . $onlinetime . $reading_sql . ' 
                    group by u.user_id
                ) s on u.user_id = s.user_id ' . $limit; $result = $db->sql_query($sql); $members = array(); while ($member = $db->sql_fetchrow($result)) { $tmp = new UserModel($member); $members[] = $tmp->output(); } $db->sql_freeresult($result); return array( 'registered' => '', 'guest' => '', 'hidden' => '', 'list' => $members ); } public static function getUsers($case = 'online', $in = array()) { global $config, $db; UserFunctions::checkAuth(array('u_viewprofile')); $page = isset($in['page']) ? $in['page'] : 1; $perpage = isset($in['perpage']) ? $in['perpage'] : 20; $start = ($page - 1) * $perpage; $limit = "LIMIT $start , $perpage"; switch ($case) { case 'byUserIds': $userIds = implode(',', $in['userIds']); $sql = 'SELECT * FROM ' . USERS_TABLE . ' WHERE user_id IN (' . $userIds . ' )'; break; case 'recommanded': $sql = 'SELECT u.* FROM ' . USERS_TABLE . ' u WHERE u.user_type <> 2 ORDER BY u.username ' . $limit; break; case 'byUsername': $keywords = mysql_real_escape_string($in['keywords']); $sql = 'SELECT u.* FROM ' . USERS_TABLE . ' u WHERE u.user_type <> 2 and u.username COLLATE UTF8_GENERAL_CI LIKE \'%' . $keywords . '%\' ORDER BY u.username ' . $limit; break; case 'online': default: $reading_sql = ''; if ($in['id'] !== 0) { $reading_sql = ' AND s.session_forum_id = ' . (int)$in['id']; } $onlinetime = time() - ($config['load_online_time'] * 60); $sql = 'SELECT u.*, s.session_time, s.session_viewonline 
                        FROM ' . USERS_TABLE . ' u
                        JOIN (
                            SELECT u.user_id, MAX(s.session_time) as session_time, MIN(s.session_viewonline) AS session_viewonline
                            FROM ' . USERS_TABLE . ' AS u
                            LEFT JOIN ' . SESSIONS_TABLE .' AS s ON u.user_id = s.session_user_id
                            WHERE u.user_type <> 2 AND session_viewonline = 1 AND session_time > ' . $onlinetime . $reading_sql . ' 
                            group by u.user_id
                        ) s on u.user_id = s.user_id ' . $limit; break; } $result = $db->sql_query($sql); $members = array(); while ($member = $db->sql_fetchrow($result)) { $tmp = new UserModel($member); $members[] = $tmp->output(); } $db->sql_freeresult($result); return $members; } public static function registerUser($in, $verif, &$errors) { global $config,$db, $user, $auth, $phpbb_root_path, $phpEx,$phpbb_container; $email = $in['email']; $username = $in['username']; $password = $in['password']; $verified = $verif['emailStatus'] == '1'; $profile = $verif['profile']; if ($u = UserModel::getUserByEmail($email)) { if ($u->bind['user_type'] == USER_INACTIVE) { TIFunctions::generateError('oauth_error_inactive_account', array($in['email'])); } else { TIFunctions::generateError('USER_EMAIL_ALREADY_EXISTS', array($email)); } } require_once $phpbb_root_path . '/includes/functions_user.' . $phpEx; $user->session_kill(); $user->setup('ucp'); if ($config['require_activation'] == USER_ACTIVATION_DISABLE) { $errors[] = $user->lang['UCP_REGISTER_DISABLE']; } else { $is_dst = $config['board_dst']; $timezone = $config['board_timezone']; $data = array( 'username' => utf8_normalize_nfc($username), 'new_password' => $password, 'password_confirm' => $password, 'email' => strtolower($email), 'email_confirm' => strtolower($email), 'lang' => basename($user->lang_name), 'tz' => (float) $timezone, ); $config['pass_complex'] = 'PASS_TYPE_ANY'; $errors = validate_data($data, array( 'username' => array( array('string', false, $config['min_name_chars'], $config['max_name_chars']), array('username', '') ), 'email' => array(array('string', false, 6, 60),array('email')), 'email_confirm' => array('string', false, 6, 60), 'tz' => array('num', false, -14, 14), 'lang' => array('language_iso_name'), )); $errors = preg_replace_callback('#^([A-Z_]+)$#', function($matches) { return (!empty($user->lang[$matches[1]])) ? $user->lang[$matches[1]] : $matches[1];}, $is_dst); $phpbb_container->set('user', $user); $cpDatas = array(); } if (empty($errors)) { $errors = []; if (empty($config['topicit_register_group'])) { $groupName = 'REGISTERED'; $groupId = 0; $sql = 'SELECT group_id FROM ' . GROUPS_TABLE . " WHERE group_name = '" . $db->sql_escape($groupName) . "' AND group_type = " . GROUP_SPECIAL; $result = $db->sql_query($sql); $row = $db->sql_fetchrow($result); $db->sql_freeresult($result); if (empty($row)) { $errors[] = $user->lang['NO_GROUP']; } else { $groupId = $row['group_id']; } } else { $groupId = $config['topicit_register_group']; } $autoApprove = !empty($config['topicit_auto_approve']) ? true : false; $isForm = ($verif['userhash'] == $password) ? false : true; if( $config['require_activation'] == USER_ACTIVATION_NONE || ($autoApprove && $verified && !$isForm) ) { $user_type = USER_NORMAL; $user_actkey = ''; $user_inactive_reason = 0; $user_inactive_time = 0; $config['require_activation'] = USER_ACTIVATION_NONE; } else { $user_type = USER_INACTIVE; $user_inactive_reason = INACTIVE_REGISTER; $user_inactive_time = time(); } $userDatas = array( 'username' => $data['username'], 'user_password' => phpbb_hash($data['new_password']), 'user_email' => $data['email'], 'group_id' => $groupId, 'user_timezone' => $data['tz'], 'user_lang' => $data['lang'], 'user_type' => $user_type, 'user_actkey' => $user_actkey, 'user_ip' => $user->ip, 'user_regdate' => time(), 'user_inactive_reason' => $user_inactive_reason, 'user_inactive_time' => $user_inactive_time, ); if ($config['new_member_post_limit']) { $user_row['user_new'] = 1; } if (!empty($profile)) { if (!empty($profile['birthday']) && $config['allow_birthdays']) { $birthday = explode('-', $profile['birthday']); $userDatas['user_birthday'] = sprintf('%2d-%2d-%4d', $birthday[2], $birthday[1], $birthday[0]); } $userDatas['user_sig'] = $profile['signature']; } $userId = user_add($userDatas, $cpDatas); if (!empty($config['topicit_register_group']) && $config['topicit_register_group'] != $groupId) { group_user_add($config['topicit_register_group'], $userId); } if ($config['require_activation'] == USER_ACTIVATION_SELF && $config['email_enable']) { $message = $user->lang['ACCOUNT_INACTIVE']; $emailTemplate = 'user_welcome_inactive'; } elseif($config['require_activation'] == USER_ACTIVATION_ADMIN && $config['email_enable']) { $message = $user->lang['ACCOUNT_INACTIVE_ADMIN']; $emailTemplate = 'admin_welcome_inactive'; } if ($config['email_enable'] && $user_type == USER_INACTIVE) { $serverUrl = generate_board_url(); include_once $phpbb_root_path . 'includes/functions_messenger.' . $phpEx; $messenger = new messenger(false); $messenger->template($emailTemplate, $data['lang']); $messenger->to($data['email'], $data['username']); if (!method_exists($messenger, 'anti_abuse_headers')) { $messenger->headers('X-AntiAbuse: Board servername - ' . $config['server_name']); $messenger->headers('X-AntiAbuse: User_id - ' . $user->data['user_id']); $messenger->headers('X-AntiAbuse: Username - ' . $user->data['username']); $messenger->headers('X-AntiAbuse: User IP - ' . $user->ip); } else { $messenger->anti_abuse_headers($config, $user); } $messenger->assign_vars(array( 'WELCOME_MSG' => htmlspecialchars_decode(sprintf($user->lang['WELCOME_SUBJECT'], $config['sitename'])), 'USERNAME' => htmlspecialchars_decode($data['username']), 'PASSWORD' => htmlspecialchars_decode($data['new_password']), 'U_ACTIVATE' => "{$serverUrl}/ucp.{$phpEx}?mode=activate&u={$userId}&k={$user_actkey}" )); $messenger->send(NOTIFY_EMAIL); if ($config['require_activation'] == USER_ACTIVATION_ADMIN) { $admins = $auth->acl_get_list(false, 'a_user', false); $admins = (!empty($admins[0]['a_user'])) ? $admins[0]['a_user'] : array(); $where_sql = ' WHERE user_type = ' . USER_FOUNDER; if (!empty($admins)) { $where_sql .= ' OR ' . $db->sql_in_set('user_id', $admins); } $sql = 'SELECT user_id, username, user_email, user_lang, user_jabber, user_notify_type FROM ' . USERS_TABLE . ' ' . $where_sql; $result = $db->sql_query($sql); while ($row = $db->sql_fetchrow($result)) { $messenger->template('admin_activate', $row['user_lang']); $messenger->to($row['user_email'], $row['username']); $messenger->im($row['user_jabber'], $row['username']); $messenger->assign_vars(array( 'USERNAME' => htmlspecialchars_decode($data['username']), 'U_USER_DETAILS' => "{$serverUrl}/memberlist.{$phpEx}?mode=viewprofile&u={$userId}", 'U_ACTIVATE' => "{$serverUrl}/ucp.{$phpEx}?mode=activate&u={$userId}&k={$user_actkey}") ); $messenger->send($row['user_notify_type']); } $db->sql_freeresult($result); } } switch($config['require_activation']) { case USER_ACTIVATION_SELF: $errors[] = $user->lang['PLUG_USER_ACTIVATION_SELF']; break; case USER_ACTIVATION_ADMIN: $errors[] = $user->lang['PLUG_USER_ACTIVATION_ADMIN']; break; case USER_ACTIVATION_NONE: default: return UserModel::getUserById($userId); } } return false; } public static function addFriend($id) { global $config,$db, $user, $auth, $phpbb_root_path, $phpbb_dispatcher, $table_prefix; if (!$user->data['is_registered']) { TIFunctions::generateError('GENERAL_DENIED'); } if (!$friend = UserModel::getUserById($id)) { TIFunctions::generateError('USER_NOT_EXISTS'); } $sql = "SELECT * FROM " . ZEBRA_TABLE . " WHERE user_id = " . (int)$user->data['user_id'] . " AND zebra_id = " . (int)$friend->userId; $query = $db->sql_query($sql); if ($result = $db->sql_fetchrow($query)) { TIFunctions::generateError('IS_ALREADY_FRIEND'); } $sql_ary = array(); $sql_ary[] = array( 'user_id' => (int)$user->data['user_id'], 'zebra_id' => (int)$friend->userId, 'friend' => 1 ); $vars = array('mode', 'sql_ary'); extract($phpbb_dispatcher->trigger_event('core.ucp_add_zebra', compact($vars))); $db->sql_multi_insert(ZEBRA_TABLE, $sql_ary); Stream::returnSuccess(); } public static function removeFriend($id) { global $config,$db, $user, $auth, $phpbb_root_path, $phpbb_dispatcher, $table_prefix; if (!$user->data['is_registered']) { TIFunctions::generateError('GENERAL_DENIED'); } if (!$friend = UserModel::getUserById($id)) { TIFunctions::generateError('USER_NOT_EXISTS'); } $sql = "SELECT * FROM " . ZEBRA_TABLE . " WHERE user_id = " . (int)$user->data['user_id'] . " AND zebra_id = " . (int)$friend->userId; $query = $db->sql_query($sql); if (!$result = $db->sql_fetchrow($query)) { TIFunctions::generateError('IS_NOT_FRIEND'); } $sql = 'DELETE FROM ' . ZEBRA_TABLE . '
                WHERE user_id = ' . (int)$user->data['user_id'] . '
                AND zebra_id = ' . (int)$friend->userId; if (!$db->sql_query($sql)) { TIFunctions::generateError('DELETE_ERROR'); } Stream::returnSuccess('success'); } public static function getFriends($id = null) { global $db, $user; if (!$user->data['is_registered']) { TIFunctions::generateError('GENERAL_DENIED'); } $id = is_null($id) ? (int)$user->data['user_id'] : (int)$id; $sql = 'SELECT u.*
                FROM ' . ZEBRA_TABLE . ' z, ' . USERS_TABLE . ' u
                WHERE z.user_id = ' . $id . "
                        AND z.friend = 1
                        AND u.user_id = z.zebra_id
                ORDER BY u.username_clean ASC"; $result = $db->sql_query($sql); while ($row = $db->sql_fetchrow($result)) { $tmp = new UserModel($row); $friends[] = $tmp->output(); } $db->sql_freeresult($result); return $friends; } public static function updatePassword($in) { global $phpbb_root_path, $phpEx, $request, $user, $template; if (!$user->data['is_registered']) { TIFunctions::generateError('GENERAL_DENIED'); } App::getInstance()->error(MiscFunctions::errorHandler()); require_once($phpbb_root_path . 'includes/functions_user.' . $phpEx); require_once($phpbb_root_path . 'includes/functions_module.' . $phpEx); $request->overwrite('i', $user->data['user_id']); $request->overwrite('new_password', $in['new_password']); $request->overwrite('password_confirm', $in['new_password']); $request->overwrite('cur_password', $in['old_password']); $creation_time = time() - 3600; $token_sid = ($user->data['user_id'] == ANONYMOUS && !empty($config['form_token_sid_guests'])) ? $user->session_id : ''; $key = sha1($creation_time . $user->data['user_form_salt'] . 'ucp_reg_details' . $token_sid); $request->overwrite('creation_time', $creation_time, \phpbb\request\request_interface::POST); $request->overwrite('form_token', $key, \phpbb\request\request_interface::POST); $request->overwrite('creation_time', $creation_time, \phpbb\request\request_interface::REQUEST); $request->overwrite('form_token', $key, \phpbb\request\request_interface::REQUEST); $request->overwrite('submit', true,\phpbb\request\request_interface::POST); require_once __DIR__ . '/../clones/template.' . $phpEx; $template = new Template(); $user->setup('ucp'); $module = new p_master(); $module->load('ucp', 'profile', 'reg_details'); $error = $template->getTemplateVar('ERROR'); if (isset($error) && !empty($error)) { $errors = explode('<br />', $error); if (is_array($errors)) { return TIFunctions::generateError($errors[0]); } return TIFunctions::generateError($error); } return true; } public static function updateEmail($in) { global $phpbb_root_path, $phpEx, $request, $user, $template; if (!$user->data['is_registered']) { TIFunctions::generateError('GENERAL_DENIED'); } App::getInstance()->error(MiscFunctions::errorHandler()); require_once($phpbb_root_path . 'includes/functions_user.' . $phpEx); require_once($phpbb_root_path . 'includes/functions_module.' . $phpEx); $request->overwrite('i', $user->data['user_id']); $request->overwrite('email', $in['email']); $request->overwrite('cur_password', $in['password']); $creation_time = time() - 3600; $token_sid = ($user->data['user_id'] == ANONYMOUS && !empty($config['form_token_sid_guests'])) ? $user->session_id : ''; $key = sha1($creation_time . $user->data['user_form_salt'] . 'ucp_reg_details' . $token_sid); $request->overwrite('creation_time', $creation_time, \phpbb\request\request_interface::POST); $request->overwrite('form_token', $key, \phpbb\request\request_interface::POST); $request->overwrite('creation_time', $creation_time, \phpbb\request\request_interface::REQUEST); $request->overwrite('form_token', $key, \phpbb\request\request_interface::REQUEST); $request->overwrite('submit', true,\phpbb\request\request_interface::POST); require_once __DIR__ . '/../clones/template.' . $phpEx; $template = new Template(); $user->setup('ucp'); $module = new p_master(); $module->load('ucp', 'profile', 'reg_details'); $error = $template->getTemplateVar('ERROR'); if (isset($error) && !empty($error)) { $errors = explode('<br />', $error); if (is_array($errors)) { return TIFunctions::generateError($errors[0]); } return TIFunctions::generateError($error); } return true; } } 