<?php
 final class TopicModel extends TITopicModel { public function __construct($data = array(), $populate = false) { global $user, $auth, $config, $phpEx; if (!empty($data)) { $this->topicId = isset($data['topic_id']) ? $data['topic_id'] : null; $this->forumId = isset($data['forum_id']) ? $data['forum_id'] : null; $this->topicTitle = isset($data['topic_title']) ? html_entity_decode($data['topic_title']) : null; $this->state = isset($data['topic_status']) ? $data['topic_status'] : null; $this->realTopicId = !empty($data['topic_moved_id']) ? $data['topic_moved_id'] : $data['topic_id']; $this->topicUrl = generate_board_url() . '/viewtopic.' . $phpEx . '?f=' . $this->forumId . '&t=' . $this->topicId; $postCount = $this->getPostCount(); $this->totalPostNum = $postCount; $this->replyNumber = $postCount - 1; $this->viewNumber = isset($data['topic_views']) ? $data['topic_views'] : null; $this->participatedUids = $this->getParticipatedUIDs(); $this->topicAuthorId = isset($data['topic_poster']) ? $data['topic_poster'] : null; $this->authorIconUrl = (isset($data['user_avatar']) && isset($data['user_avatar_type'])) ? UserFunctions::getUserAvatarUrl($data['user_avatar'], $data['user_avatar_type']) : null; $this->firstPostId = isset($data['topic_first_post_id']) ? $data['topic_first_post_id'] : null; $this->topicContent = isset($data['post_text']) ? $data['post_text'] : null; $this->shortContent = isset($this->topicContent) ? ParseFunctions::shortContent($this->topicContent) : null; $this->lastReplyAuthorId = isset($data['topic_last_poster_id']) ? $data['topic_last_poster_id'] : null; $this->lastReplyAuthorName = isset($data['topic_last_poster_name']) ? $data['topic_last_poster_name'] : null; $this->lastReplyTime = isset($data['topic_last_post_time']) ? $data['topic_last_post_time'] : null; $this->lastReplyId = isset($data['topic_last_post_id']) ? $data['topic_last_post_id'] : null; $this->postTime = isset($data['topic_time']) ? DateFunctions::topicitFormatDate($data['topic_time']) : null; $this->participants = TopicModel::getParticipants($this->topicId); $key = array_search($this->lastReplyAuthorId, array_column($this->participants, 'user_id')); $this->iconUrl = isset($this->participants[$key]) && isset($this->participants[$key]['avatar']) ? $this->participants[$key]['avatar'] : $this->authorIconUrl; $this->isDeleted = isset($data['topic_visibility']) ? $data['topic_visibility'] == ITEM_DELETED : false; $this->isApproved = isset($data['topic_visibility']) ? $data['topic_visibility'] != ITEM_UNAPPROVED : false; $this->isSticky = isset($data['topic_type']) ? $data['topic_type'] == POST_STICKY : false; $this->isClosed = isset($data['topic_status']) ? $data['topic_status'] == ITEM_LOCKED : false; $this->isMoved = !empty($data['topic_moved_id']) ? true : false; $this->isSubscribed = UserFunctions::isSubscribed('topic', $this->topicId); $this->adsEnable = AdsController::displayAds($this->topicTitle); $this->canSubscribe = (($config['email_enable'] || $config['jab_enable']) && $config['allow_topic_notify'] && $user->data['is_registered']) ? true : false; $this->canBan = (bool)$auth->acl_get('m_ban') && $data['topic_last_poster_id'] != $user->data['user_id']; $this->canStick = (bool)$auth->acl_get('f_sticky', $this->forumId); $this->canClose = (bool)$auth->acl_get('m_lock', $this->forumId) || ($auth->acl_get('f_user_lock', $this->forumId) && $user->data['is_registered'] && $user->data['user_id'] == $data['topic_poster']); $this->canMove = (bool)$auth->acl_get('m_move', $this->forumId); $this->canReply = (bool)$auth->acl_get('f_reply', $this->forumId) && $data['forum_status'] != ITEM_LOCKED && $data['topic_status'] != ITEM_LOCKED; $this->canDelete = (bool)$auth->acl_get('m_delete', $this->forumId); $this->canApprove = (bool)$auth->acl_get('m_approve', $this->forumId) && !$this->isApproved; $this->canRename = ($user->data['is_registered'] && ($auth->acl_get('m_edit', $this->forumId) || ($user->data['user_id'] == $data['topic_poster'] && $auth->acl_get('f_edit', $this->forumId) && ($data['topic_time'] > time() - ($config['edit_time'] * 60) || !$config['edit_time'])))); $this->canReport = (bool)$auth->acl_get('m_report', $this->forumId); $this->bind = $data; } if ($populate) { if (empty($this->topicContent)) { $this->topicContent = PostController::getPostContent($this->lastReplyId); $this->shortContent = ParseFunctions::shortContent($this->topicContent); } } } private function getPostCount() { global $db; $count = 0; if (!empty($this->topicId)) { $sql = 'SELECT count(post_id) as count FROM ' . POSTS_TABLE . ' WHERE topic_id = ' . (int)$this->topicId; $query = $db->sql_query($sql); $result = $db->sql_fetchrow($query); $count = $result['count']; } return $count; } private function getParticipatedUIDs() { global $db; $uids = array(); if (!empty($this->topicId)) { $sql = 'SELECT poster_id FROM ' . POSTS_TABLE . ' WHERE topic_id = ' . (int)$this->topicId . ' GROUP BY poster_id'; $query = $db->sql_query($sql); while ($result = $db->sql_fetchrow($query)) { $uids[] = (int)$result['poster_id']; } } return $uids; } public function getAuthorName() { return UserFunctions::getUsernameById($this->topicAuthorId); } public function getForum() { return ForumModel::getForumById($this->forumId); } public static function getTopicById($id) { global $db; $row = array(); if (!empty($id)) { $sql = 'SELECT p.post_text,t.*, u.user_avatar, u.user_avatar_type FROM ' . POSTS_TABLE . ' AS p RIGHT JOIN ' . TOPICS_TABLE . ' AS t ON p.topic_id = t.topic_id AND p.post_id = t.topic_last_post_id LEFT JOIN ' . USERS_TABLE . ' AS u ON t.topic_poster = u.user_id WHERE t.topic_id = ' . (int)$id; $result = $db->sql_query($sql); $row = $db->sql_fetchrow($result); } return !empty($row) ? new self($row) : false; } public static function getTopicsByIds($ids) { global $db; $topics = array(); if (!empty($ids) && is_array($ids)) { $ids = implode(',', $ids); $sql = 'SELECT p.post_text, t.*, u.user_avatar, u.user_avatar_type FROM ' . POSTS_TABLE . ' AS p RIGHT JOIN ' . TOPICS_TABLE . ' AS t ON p.topic_id = t.topic_id AND p.post_id = t.topic_last_post_id LEFT JOIN ' . USERS_TABLE . ' AS u ON t.topic_poster = u.user_id WHERE t.topic_id IN(' . $db->sql_escape($ids) . ')'; $result = $db->sql_query($sql); while ($row = $db->sql_fetchrow($result)) { $topics[] = new self($row); } } return $topics; } public function setFirstUnreadPosition() { global $db, $user; $trakingInfo = get_complete_topic_tracking($this->forumId, $this->topicId); $timestamp = $trakingInfo[$this->topicId]; $userId = $user->data['user_id']; if (!empty($timestamp)) { $sql = 'SELECT t.total - u.unread AS position, t.total, u.unread
                    FROM (
                        SELECT count(post_id) AS total FROM ' . POSTS_TABLE . '
                        WHERE topic_id = ' . (int)$this->topicId . ' AND post_visibility = 1
                    ) t
                    LEFT JOIN (
                        SELECT count(post_id) AS unread FROM ' . POSTS_TABLE . '
                        WHERE topic_id = ' . (int)$this->topicId . ' AND post_visibility = 1 AND post_time > ' . $timestamp . '
                    ) u ON 1=1'; } else { $sql = 'SELECT t.total - u.unread AS position, t.total, u.unread
                    FROM (
                        SELECT count(post_id) AS total FROM ' . POSTS_TABLE . '
                        WHERE topic_id = ' . (int)$this->topicId . ' AND post_visibility = 1
                    ) t
                    LEFT JOIN (
                        SELECT count(post_id) AS unread FROM ' . POSTS_TABLE . '
                        WHERE topic_id = ' . (int)$this->topicId . ' AND post_visibility = 1 AND post_time > (
                            SELECT case when MAX(mark_time) IS NULL then 0 else MAX(mark_time) end as mark_time FROM ' . TOPICS_TRACK_TABLE . ' WHERE topic_id = ' . (int)$this->topicId . ' AND user_id = ' . (int)$userId . '
                        )
                    ) u ON 1=1'; } $result = $db->sql_query($sql); $row = $db->sql_fetchrow($result); $this->firstUnreadPosition = $row['position']; } public function getLastPost() { global $db; $sql = 'SELECT p.*, u.user_avatar, u.user_avatar_type FROM ' . POSTS_TABLE . ' AS p LEFT JOIN ' . USERS_TABLE . ' AS u ON p.poster_id = u.user_id WHERE post_id = ' . (int)$this->lastReplyId . ' AND topic_id = ' . (int)$this->topicId; $result = $db->sql_query($sql); $row = $db->sql_fetchrow($result); return new PostModel($row); } public static function getParticipants($id) { global $db; $participants = array(); if (!empty($id)) { $sql = 'SELECT u.user_id, u.username, u.user_avatar_type, u.user_avatar 
                    FROM ' . POSTS_TABLE . ' AS p  
                    RIGHT JOIN ' . USERS_TABLE . ' AS u ON p.poster_id = u.user_id 
                    WHERE p.topic_id = ' . (int)$id . ' 
                    GROUP BY p.poster_id'; $result = $db->sql_query($sql); while ($row = $db->sql_fetchrow($result)) { $participants[] = [ 'user_id' => $row['user_id'], 'username' => $row['username'], 'avatar' => UserFunctions::getUserAvatarUrl($row['user_avatar'], $row['user_avatar_type']) ]; } } return $participants; } } 