<?php
 final class SearchController implements SearchInterface { public static function search($mode, $start, $limit, $filter = array()) { global $request, $db, $template, $user, $auth, $config, $can_subscribe, $show_results, $include_topic_num, $total_match_count, $request_method, $searchResults, $table_prefix; switch ($mode) { case 'getLatest': $request_method = 'get_latest_topic'; $include_topic_num = true; $request->overwrite('page', $start); $request->overwrite('perpage', $limit); $request->overwrite('search_id', 'latesttopics'); require __DIR__ . '/../clones/search.php'; $result = array(); if (!empty($searchResults)) { foreach ($searchResults as $item) { $result[] = new TopicModel($item['bind'], true); } } return array( 'total' => $total_match_count, 'topics' => $result ); break; case 'getUnread': $request_method = 'get_unread_topic'; $include_topic_num = true; $request->overwrite('page', $start); $request->overwrite('perpage', $limit); $request->overwrite('search_id', 'unreadposts'); require __DIR__ . '/../clones/search.php'; $result = array(); if (!empty($searchResults)) { foreach ($searchResults as $item) { $result[] = new TopicModel($item['bind'], true); } } return array( 'total' => $total_match_count, 'topics' => $result ); break; case 'getParticipated': $request_method = 'get_participated_topic'; $include_topic_num = true; $request->overwrite('page', $start); $request->overwrite('perpage', $limit); $request->overwrite('sr', 'topics'); $request->overwrite('submit', 'Search'); $request->overwrite('search_id', 'getParticipatedTopic'); switch ($filter['by']) { case 'id': $request->overwrite('author_id', (int)$filter['id']); break; case 'username': $request->overwrite('author', $filter['id']); break; case 'searchid': default: $request->overwrite('search_id', 'egosearch'); break; } require __DIR__ . '/../clones/search.php'; $result = array(); if (!empty($searchResults)) { foreach ($searchResults as $item) { $result[] = new TopicModel($item['bind'], true); } } return array( 'total' => $total_match_count, 'unread' => null, 'topics' => $result ); break; case 'getUserTopics': $request_method = 'search'; $include_topic_num = true; $request->overwrite('page', $start); $request->overwrite('perpage', $limit); $request->overwrite('submit', 'Search'); $request->overwrite('sr', 'topics'); $request->overwrite('sf', 'all'); $request->overwrite(($filter['by'] == 'username' ? 'author' : 'author_id'), $filter['id']); require __DIR__ . '/../clones/search.php'; $result = array(); if (!empty($searchResults)) { foreach ($searchResults as $item) { $result[] = new TopicModel($item['bind'], true); } } return array( 'total' => $total_match_count, 'topics' => $result ); break; case 'getUserReplies': $request_method = 'search'; $include_topic_num = true; $request->overwrite('page', $start); $request->overwrite('perpage', $limit); $request->overwrite('submit', 'Search'); $request->overwrite('sr', 'posts'); $request->overwrite('sf', 'all'); $request->overwrite(($filter['by'] == 'username' ? 'author' : 'author_id'), $filter['id']); require __DIR__ . '/../clones/search.php'; $result = array(); if (!empty($searchResults)) { foreach ($searchResults as $item) { $result[] = new PostModel($item['bind']); } } return array( 'total' => $total_match_count, 'posts' => $result ); break; case 'searchTopic': $include_topic_num = true; $request->overwrite('page', $start); $request->overwrite('perpage', $limit); $request->overwrite('submit', 'Search'); $request->overwrite('sr', 'topics'); $request->overwrite('sf', 'all'); $request->overwrite('keywords', $filter['keywords']); require __DIR__ . '/../clones/search.php'; $result = array(); if (!empty($searchResults)) { foreach ($searchResults as $item) { $result[] = new TopicModel($item['bind'], true); } } return array( 'total' => $total_match_count, 'topics' => $result ); break; case 'searchPost': $include_topic_num = true; $request_file = 'search'; $request->overwrite('page', $start); $request->overwrite('perpage', $limit); $request->overwrite('submit', 'Search'); $request->overwrite('sr', 'posts'); $request->overwrite('sf', 'all'); $request->overwrite('keywords', $filter['keywords']); require __DIR__ . '/../clones/search.php'; $result = array(); if (!empty($searchResults)) { foreach ($searchResults as $item) { $result[] = new PostModel($item['bind']); } } return array( 'total' => $total_match_count, 'posts' => $result ); break; case 'search': $request_method = 'search'; $include_topic_num = true; $request->overwrite('page', $start); $request->overwrite('perpage', $limit); $request->overwrite('submit', 'Search'); $request->overwrite('sr', $filter['showPosts'] ? 'posts' : 'topics'); if($filter['titleOnly']) { $request->overwrite('sf', 'titleonly'); } elseif(($filter['userId'] || $filter['searchUser']) && $filter['showPosts'] == false) { $request->overwrite('sf', 'firstpost'); } else { $request->overwrite('sf', 'all'); } $request->overwrite('searchid', $filter['searchId']); $request->overwrite('keywords', $filter['keywords']); $request->overwrite('author', $filter['searchUser']); $request->overwrite('author_id', $filter['userId']); $request->overwrite('fid', isset($filter['forumId']) ? array($filter['forumId']) : $filter['forumId']); if (!empty($filter['topicId'])) { $request->overwrite('t', $filter['topicId']); $request->overwrite('sf', 'msgonly'); $request->overwrite('showresults', 'posts'); } if (!empty($filter['searchTime']) && is_numeric($filter['searchTime'])) { $request->overwrite('st', $filter['searchTime']/86400); } if (isset($filter['onlyIn']) && is_array($filter['onlyIn'])) { $request->overwrite('fid', array_map('intval', $filter['onlyIn'])); } if (isset($filter['notIn']) && is_array($filter['notIn'])) { $request->overwrite('exclude', array_map('intval', $filter['notIn'])); } require __DIR__ . '/../clones/search.php'; $result = array(); if ($filter['showPosts']) { if(!empty($searchResults)) { foreach($searchResults as $item) { $result[] = new PostModel($item['bind']); } } } else { if(!empty($searchResults)) { foreach($searchResults as $item) { $result[] = new TopicModel($item['bind'], true); } } } return array( 'total' => $total_match_count, 'results' => $result ); break; case 'popular' : $repliesScore = 75; $viewsScore = 25; $sql = "SELECT ((COUNT(p.post_id)*{$repliesScore}) + ({$viewsScore}*topic_views)) as score FROM {$table_prefix}topics t, {$table_prefix}posts p WHERE t.topic_id = p.topic_id GROUP BY p.topic_id ORDER BY score DESC LIMIT 1"; $query = $db->sql_query($sql); if(! $result = $db->sql_fetchrow($query)) { TIFunctions::generateError('SQL_ERROR'); } $maxScore = $result['score']; $topics = self::getPopularTopics($maxScore, 0, 20); return $topics; break; case 'active' : $request_method = 'active_topics'; $include_topic_num = true; $request->overwrite('page', $start); $request->overwrite('perpage', $limit); $request->overwrite('search_id', 'active_topics'); require __DIR__ . '/../clones/search.php'; $result = array(); if (!empty($searchResults)) { foreach ($searchResults as $item) { $result[] = new TopicModel($item['bind'], true); } } return $result; break; } } public static function getPopularTopics($maxScore, $start, $limit) { global $db, $table_prefix, $auth; $repliesScore = 75; $viewsScore = 25; $sql = "SELECT t.*, u.user_avatar, u.user_avatar_type, p.post_text , ROUND((((COUNT(p.post_id)*{$repliesScore}) + ({$viewsScore}*topic_views)) * 100) / $maxScore , 2) as score FROM {$table_prefix}topics t, {$table_prefix}posts p, {$table_prefix}users u WHERE t.topic_id = p.topic_id AND t.topic_poster = u.user_id GROUP BY p.topic_id ORDER BY score DESC LIMIT {$start}, {$limit}"; $query = $db->sql_query($sql); $topics = array(); $missing = 0; while ($row = $db->sql_fetchrow($query)) { if (!$auth->acl_get('f_', $row['forum_id'])) { $missing++; } else { $topics[] = new TopicModel($row); } } if ($missing) { array_merge($topics, self::getPopularTopics($maxScore, $start + $limit , $missing)); } return $topics; } } 