<?php
 final class ForumModel extends TIForumModel { public function __construct($data = array(), $populate = false) { global $user, $config, $auth; if (!empty($data)) { $this->forumId = isset($data['forum_id']) ? $data['forum_id'] : null; $this->forumName = isset($data['forum_name']) ? TIFunctions::clean($data['forum_name']) : null; $this->description = isset($data['description']) ? $data['description'] : ''; $this->totalTopicNum = isset($data['total_topic_num']) ? $data['total_topic_num'] : null; $this->totalPostNum = isset($data['total_post_num']) ? $data['total_post_num'] : null; $this->parentId = isset($data['parent_id']) ? $data['parent_id'] : null; $this->logoUrl = isset($data['logo_url']) ? $data['logo_url'] : null; $this->url = isset($data['url']) ? $data['url'] : null; $this->unreadTopicNum = isset($data['unread_topic_num']) ? $data['unread_topic_num'] : null; $this->unreadStickyCount = isset($data['unread_sticky_count']) ? $data['unread_sticky_count'] : null; $this->unreadAnnounceCount = isset($data['unread_announce_count']) ? $data['unread_announce_count'] : null; $this->requirePrefix = isset($data['require_prefix']) ? $data['require_prefix'] : null; $this->prefixes = isset($data['prefixes']) ? $data['prefixes'] : null; $this->forumPassword = isset($data['forum_password']) ? $data['forum_password'] : null; $this->forumType = isset($data['forum_type']) ? $data['forum_type'] : null; $this->state = isset($data['forum_status']) ? $data['forum_status'] : null; $this->subOnly = ($this->forumType != FORUM_POST); $this->newPost = !empty($this->unreadTopicNum); $this->lastPostTime = isset($data['forum_last_post_time']) ? $data['forum_last_post_time'] : null; $this->isProtected = isset($data['forum_password']) ? !empty($data['forum_password']) : null; $this->isSubscribed = UserFunctions::isSubscribed('forum', $this->forumId); $this->canSubscribe = $user->data['is_registered'] && ($config['email_enable'] || $config['jab_enable']) && $config['allow_forum_notify'] && $this->forumType == FORUM_POST && $auth->acl_get('f_subscribe', $this->forumId); $this->canPost = $auth->acl_get('f_post', $this->forumId); $this->canUpload = ($this->canPost && !$auth->acl_get('u_attach')); $this->bind = $data; if ($populate) { $this->totalTopicNum = $this->countTotalTopic(); $this->unreadTopicNum = count(get_unread_topics(false, "AND t.forum_id = " . $this->forumId)); $this->unreadStickyCount = $this->countUnreadSticky(); $this->unreadAnnounceCount = $this->countUnreadAnnounce(); } } } private function countUnreadSticky() { global $user, $db, $auth; $unreadStickyCount = 0; if (!empty($this->forumId) && $user->data['user_id'] != ANONYMOUS) { $movedTopics = ForumController::getMovedTopics($this->forumId); $sqlMovedTopics = empty($movedTopics) ? '' : 'AND ' . $db->sql_in_set('t.topic_moved_id', $movedTopics, true); $result = $db->sql_query('SELECT t.topic_id, t.topic_last_post_time FROM ' . TOPICS_TABLE . ' t WHERE t.forum_id = ' . (int)$this->forumId.' AND t.topic_type = ' . POST_STICKY . " " . $sqlMovedTopics . " " . ($auth->acl_get('m_approve', (int)$this->forumId) ? '' : ' AND t.topic_visibility = 1 ')); while ($row = $db->sql_fetchrow($result)) { if (empty($row['topic_id'])) { continue; } $topicTracking = get_complete_topic_tracking($this->forumId, $row['topic_id']); if (isset($topicTracking[$row['topic_id']]) && $topicTracking[$row['topic_id']] < $row['topic_last_post_time']) { $unreadStickyCount++; } } } return $unreadStickyCount; } private function countUnreadAnnounce() { global $user, $db, $auth; $unreadAnnounceCount = 0; if (!empty($this->forumId) && $user->data['user_id'] != ANONYMOUS) { $movedTopics = ForumController::getMovedTopics($this->forumId); $sqlMovedTopics = empty($movedTopics) ? '' : 'AND ' . $db->sql_in_set('t.topic_moved_id', $movedTopics, true); $result = $db->sql_query('SELECT t.topic_id, t.topic_last_post_time FROM ' . TOPICS_TABLE . ' t WHERE t.forum_id IN (' . $this->forumId . ', 0) AND t.topic_type IN (' . POST_ANNOUNCE . ', ' . POST_GLOBAL . ") " . $sqlMovedTopics . " " . ($auth->acl_get('m_approve', (int)$this->forumId) ? '' : ' AND t.topic_visibility = 1 ')); while ($row = $db->sql_fetchrow($result)) { if (empty($row['topic_id'])) { continue; } $topicTracking = get_complete_topic_tracking($this->forumId, $row['topic_id']); if (isset($topicTracking[$row['topic_id']]) && $topicTracking[$row['topic_id']] < $row['topic_last_post_time']) { $unreadAnnounceCount++; } } $db->sql_freeresult($result); } return $unreadAnnounceCount; } private function countTotalTopic() { global $db, $auth; $topicsCount = 0; if (!empty($this->forumId)) { $movedTopics = ForumController::getMovedTopics($this->forumId); $sqlMovedTopics = empty($movedTopics) ? '' : 'AND ' . $db->sql_in_set('t.topic_moved_id', $movedTopics, true); $sql = 'SELECT count(t.topic_id) AS num_topics
                    FROM ' . TOPICS_TABLE . ' t
                    WHERE t.forum_id = ' . (int)$this->forumId . ' AND t.topic_type = ' . POST_NORMAL . ' ' . $sqlMovedTopics . ' ' . ($auth->acl_get('m_approve', (int)$this->forumId) ? '' : ' AND t.topic_visibility = 1 '); $result = $db->sql_query($sql); $topicsCount = $db->sql_fetchfield('num_topics'); $db->sql_freeresult($result); } return $topicsCount; } public static function getForumById($id) { global $db; $row = array(); if (!empty($id)) { $sql = 'SELECT * FROM ' . FORUMS_TABLE . ' WHERE forum_id = ' . (int)$id; $result = $db->sql_query($sql); $row = $db->sql_fetchrow($result); } return !empty($row) ? new self($row, true) : false; } public static function getForumsByIds($ids) { global $db; $forums = array(); if (!empty($ids) && is_array($ids)) { $ids = implode(',', $ids); $sql = 'SELECT * FROM ' . FORUMS_TABLE . ' WHERE forum_id IN(' . $db->sql_escape($ids) . ')'; $result = $db->sql_query($sql); while ($row = $db->sql_fetchrow($result)) { $forums[] = new self($row); } } return $forums; } } 