<?php
 Router::get('/board/config', 'TIBoard@getConfig'); Router::get('/board/statistics', 'TIBoard@getStats'); Router::get('/forum/idfromurl/:url', 'TIForum@getIdFromURL'); Router::post('/forum/markread/:id', 'TIForum@markRead', array('id' => '[\d]+')); Router::post('/forum/login/:id', 'TIForum@loginForum' , array('id' => '[\d]+')); Router::get('/forum/status/:ids', 'TIForum@getDetails', array('ids' => '[\d,]+')); Router::get('/forum(/:id)', 'TIForum@getForum', array('id' => '[\d]+')); Router::get('/user/avatar/:id', 'TIUser@getAvatar', array('id' => '[\d]+')); Router::get('/user/info/:id', 'TIUser@getUserInfo'); Router::put('/user/password', 'TIUser@updatePassword'); Router::put('/user/email', 'TIUser@updateEmail'); Router::get('/user/topics/:id', 'TITopic@getUserTopics', array('id' => '(.+)')); Router::get('/user/replies/:id', 'TITopic@getUserReplies', array('id' => '(.+)')); Router::post('/user/login', 'TIUser@logIn'); Router::get('/user/inboxstats', 'TIUser@getInboxStats'); Router::post('/user/retrieve/:id', 'TIUser@retrievePassword'); Router::post('/user/logout', 'TIUser@logOut'); Router::get('/users/recommanded', 'TIUser@getRecommandedUsers'); Router::get('/users/search/:keyword', 'TIUser@searchUser'); Router::get('/users/online', 'TIUser@getOnlineUsers'); Router::get('/user/friend(/:id)', 'TIUser@getFriends', array('id' => '[\d]+')); Router::post('/user/friend', 'TIUser@addFriend'); Router::delete('/user/friend/:id', 'TIUser@removeFriend', array('id' => '[\d]+')); Router::get('/topics/unread', 'TITopic@getUnread'); Router::get('/topics/latest', 'TITopic@getLatest'); Router::get('/topics/followed', 'TITopic@getFollowed'); Router::get('/topics/popular', 'TITopic@getPopular'); Router::get('/topics/active', 'TITopic@getActive'); Router::get('/topics/participated/:id', 'TITopic@getParticipated', array('id' => '(.+)')); Router::get('/topics/markread/:ids', 'TITopic@markRead', array('ids' => '[\d,]+')); Router::get('/topics/:id', 'TITopic@getTopics', array('id' => '[\d]+')); Router::get('/topics', 'TITopic@getTopicsByIdList'); Router::post('/topic/new', 'TITopic@newTopic'); Router::post('/topic/reply/:id', 'TIPost@newReply', array('id' => '[\d]+')); Router::get('/topic/unread/:id', 'TIPost@getByUnread', array('id' => '[\d]+')); Router::get('/topic/post/:id', 'TIPost@getByPost', array('id' => '[\d]+')); Router::get('/topic/:id', 'TIPost@getPosts', array('id' => '[\d]+')); Router::delete('/topic/:topicId', 'TIModeration@deleteTopic'); Router::post('/post/report/:id', 'TIPost@reportPost', array('id' => '[\d]+')); Router::get('/post/quote/:ids', 'TIPost@getQuotePost', array('ids' => '[\d,]+')); Router::get('/post/:id', 'TIPost@getPost', array('id' => '[\d]+')); Router::post('/post/:id', 'TIPost@editPost', array('id' => '[\d]+')); Router::delete('/post/:postId', 'TIModeration@deletePost'); Router::get('/search/topic/:keywords', 'TISearch@searchTopic'); Router::get('/search/post/:keywords', 'TISearch@searchPost'); Router::get('/search/adv/:keywords', 'TISearch@search'); Router::get('/subscriptions/:type', 'TISubscription@get', array('type' => 'topic|forum')); Router::post('/subscriptions/:type/:id', 'TISubscription@post', array('type' => 'topic|forum', 'id' => '[\d]+')); Router::delete('/subscriptions/:type/:id', 'TISubscription@delete', array('type' => 'topic|forum', 'id' => '[\d]+')); Router::get('/conversations', 'TIMessage@getAllMessagesList'); Router::get('/conversation/:id', 'TIMessage@getConversation', array('id' => '[\d]+')); Router::get('/message/info', 'TIMessage@getBoxInfo'); Router::get('/message/quote/:id', 'TIMessage@quoteMessage', array('id' => '[\d]+')); Router::post('/message/markread(/:ids)', 'TIMessage@markRead', array('ids' => '[\d,]+')); Router::post('/message/markunread/:id', 'TIMessage@markUnread', array('id' => '[\d]+')); Router::post('/message/report/:id', 'TIMessage@report', array('id' => '[\d]+')); Router::post('/message/new', 'TIMessage@newMessage'); Router::get('/message/:box', 'TIMessage@getMessageList', array('box' => '-?[\d\w]+')); Router::get('/message/:box/:id', 'TIMessage@getMessage', array('box' => '-?[\d\w]+', 'id' => '[\d]+')); Router::delete('/message/:box/:id', 'TIMessage@deleteMessage', array('box' => '-?[\d\w]+', 'id' => '[\d]+')); Router::post('/mod/topic/close/:topicId', 'TIModeration@closeTopic'); Router::post('/mod/topic/edit/:postId', 'TIModeration@editTopic'); Router::delete('/mod/topic/delete/:topicId', 'TIModeration@deleteTopic'); Router::post('/mod/topic/move/:topicId', 'TIModeration@moveTopic'); Router::post('/mod/topic/rename/:topicId', 'TIModeration@renameTopic'); Router::delete('/mod/post/delete/:postId', 'TIModeration@deletePost'); Router::post('/mod/post/edit/:postId', 'TIModeration@editPost'); Router::post('/mod/user/ban/:userId', 'TIModeration@banUser'); Router::delete('/mod/user/ban/:userId', 'TIModeration@unbanUser'); Router::post('/account/signin', 'TIAccount@signIn'); Router::post('/account/renew', 'TIAccount@renew'); Router::get('/connect', 'TIConnect@get'); Router::get('/feed' , 'TIFeed@get'); Router::post('/version' , 'TIVersion@get'); Router::post('/verify' , 'TIBoard@checkAPI');